##Climograma
##Francisco Alcaraz Ariza (Murcia, Spain)

##Versión 2.0, 16 de febrero de 2011
#Cambios respecto a versión 1.6, arreglado layout deformado

##Versión 1.6
#Cambios respecto a la versión 1.0: corregidos problemas con texto de caracteres especiales

climogram<-function(file,lang="es",margen=c(4,4,5,4),mlab="",pcol="#005ac8", tcol="#e81800", pfcol="cyan",sfcol="#0eb6d7",shem=FALSE) {
plot.new()
par(mar=margen,pty="s",las=1,new=FALSE,family="sans")
#################################################

#Limpiamos dat y loc de memoria por si se hubieran cargado con anterioridad
#if(exists("dat")) rm(dat)
#if(exists("loc")) rm(loc)
#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
old.par<-par(no.readonly=TRUE)
on.exit(par(old.par))

#etiquetas de los meses
mlab=c("I","II","III","IV","V","VI","VII","VIII","IX","X","XI","XII")
if(lang=="en") titulo="Climogram"
else titulo="Climograma"

#Comprobar cómo incide esto en el diagrama antes de ponerlo
hem=loc[1,7]
if(hem=="2") shem=TRUE 
else shem=FALSE
if(shem) {#Hemisferio sur: desplazar los datos medio año
m1 <- dat[1:6,]
m2 <- dat[7:12,]
dat<-rbind(m2,m1)
mlab<-c(mlab[7:12],mlab[1:6])
}
#Enlazamos los nombres de las variables a los de las columnas de los ficheros
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

nc<-ncol(dat) #Comprobamos el número de variables en dat
#Temperaturas medias mensuales
if(nc==4) {tm<-(tma+tmi)/2}
#En caso contrario es evidente que la segunda columna, interpretada por «attach» 

if(hem==1) z<-"N" else z<-"S"
if(long3==1) zz<-"E" else zz<-"W"
pm2<-c(pm[1:12],pm[1])
tm2<-c(tm[1:12],tm[1])

plot(pm2,tm2,xlab="P (mm)",ylab=expression("T "*degree*"C"),main=titulo,type="o",col = c("red","green4","blue"),pch=20)

par(family="sans")
text(pm[1:12],tm[1:12],labels=mlab,adj=c(-0.2,1.5),font=2,cex=0.8)

#rótulos
par(family="HersheySans")
mtext(paste(est," (",alt,"m), ",lat1,"\\de ",lat2,"' ",z,", ",long1,"\\de ",long2,"' ",zz,sep=""),font=3,line=0.5,adj=0.5)

invisible()


}
