##Índices de Dantin y Revenga, Lang, Holdridge, Martonne, Köppen
##Francisco Alcaraz Ariza (Murcia, Spain)

##Versión 1.5, 16 de febrero de 2011
#Cambios menores

##Versión 1.0 (20 agosto de 2009)
indices<-function(file,lang="es",margen=c(2,1,5,2),mlab="",shem=FALSE) {
par(mar=margen,pty="s",las=1,new=FALSE,cex.main=1.6,family="HersheySans")

#################################################
#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc

#Controlamos número de columnas en el fichero de datos
nc<-ncol(dat)

if(hem=="2") shem=TRUE 
else shem=FALSE
if(shem) {#Hemisferio sur: desplazar los datos medio año
m1 <- dat[1:6,]
m2 <- dat[7:12,]
dat<-rbind(m2,m1)}



#Enlazamos los nombres de las variables a los de las columnas de los ficheros
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

#Temperaturas medias mensuales
if(nc==4) {tm<-(tma+tmi)/2} #El fichero .dat tiene 4 columnas
#En caso contrario es evidente que la segunda columna, interpretada por «attach» es tm
#Se calcula la temperatura media anual y la precipitación media anual
Tm<-sum(tm)/12
Pm<-sum(pm)

######################Dantin y Revenga##########################
IDR="" #Variable que incluirá el valor del índice de Dantin y Revenga, la ponemos a cero
CDR="" #Variable para la clasificación bioclimática de Dantin y Revenga, la ponemos a cero
IDR=round(((100*Tm)/Pm),digits=1) #Ya tenemos calculado el índice, redondeado

#Ahora unos bucles para las calificaciones bioclimáticas de acuerdo con el índice
if (lang=="es") { #Si el idioma es el por defecto, castellano
if(IDR<2) CDR<-"Zona húmeda" else
if(IDR>=2 && IDR<3) CDR<-"Zona semi\\'arida" else 
if(IDR>=3 && IDR<6) CDR<-"Zona \\'arida" else CDR<-"Zona subdes\\'ertica"} else

if (lang=="en"){ #hemos dado en la entrada el lenguaje en inglés
if(IDR<2) CDR<-"Humid zone" else
if(IDR>=2 && IDR<3) CDR<-"Semiarid zone" else 
if(IDR>=3 && IDR<6) CDR<-"Arid zone" else CDR<-"Subdesertic zone"}

######################Cálculo del Índice de Lang##############################
ILang="" #Variable que incluirá el valor del índice de Lang, la ponemos a cero
CLang="" #Variable para la calificación bioclimática de Lang, la ponemos a cero
ILang=round((Pm/Tm),digits=1) #Ya tenemos calculado el índice, redondeado

#Ahora unos bucles para las calificaciones bioclimáticas de acuerdo con el índice
if (lang=="es") { #Si el idioma es el por defecto, castellano
if(ILang>=0 && ILang<20) CLang<-"Desierto" else
if(ILang>=20 && ILang<40) CLang<-"Zona \\'arida de estepas" else
if(ILang>=40 && ILang<60) CLang<-"Zona semi\\'arida de estepas y arbustos" else
if(ILang>=60 && ILang<100) CLang<-"Zona h\\'umeda de bosques ralos" else
if(ILang>=100 && ILang<160) CLang<-"Zona h\\'umeda de bosques densos" else
Clang<-"Zona hiperh\\'umeda de prados y tundra"} else

if (lang=="en"){ #hemos dado en la entrada el lenguaje en inglés
if(ILang>=0 && ILang<20) CLang<-"Desert" else
if(ILang>=20 && ILang<40) CLang<-"Stepic arid zone" else
if(ILang>=40 && ILang<60) CLang<-"Semiarid zone with stepe and shrubs" else
if(ILang>=60 && ILang<100) CLang<-"Humid zone with open forests" else
if(ILang>=100 && ILang<160) CLang<-"Humid zone with forest" else
Clang<-"Perhumid zone with pastures and polar tundra"}

###################Holdridge life zones ###############
#Clasificación Holdridge
Hold=""
hp=""

{if(Pm<125){
	if(Tm<1.5) hp<-"po" else
	if(Tm>=1.5 && Tm<3) hp<-"dt" else
	if(Tm>=3 && Tm<6) hp<-"bd" else
	if(Tm>=6 && Tm<12) hp<-"ctd" else
	if(Tm>=12 && Tm<18) hp<-"wtd" else
	if(Tm>=18 && Tm<=24) hp<-"sd" else
	if(Tm>24) hp<-"td"} else

if(Pm>=125 && Pm<250){
	if(Tm<1.5) hp<-"po" else
	if(Tm>=1.5 && Tm<3) hp<-"mt" else
	if(Tm>=3 && Tm<6) hp<-"ds" else
	if(Tm>=6 && Tm<12) hp<-"ctds" else
	if(Tm>=12 && Tm<18) hp<-"wtds" else
	if(Tm>=18 && Tm<=24) hp<-"sds" else
	if(Tm>24) hp<-"tds"} else

if(Pm>=250 && Pm<500){
	if(Tm<1.5) hp<-"po" else
	if(Tm>=1.5 && Tm<3) hp<-"wt" else
	if(Tm>=3 && Tm<6) hp<-"mf" else
	if(Tm>=6 && Tm<12) hp<-"ste" else
	if(Tm>=12 && Tm<18) hp<-"tste" else
	if(Tm>=18 && Tm<=24) hp<-"stw" else
	if(Tm>24) hp<-"ttw"} else

if(Pm>=500 && Pm<1000){
	if(Tm>=1.5 && Tm<3) hp<-"rt" else
	if(Tm>=3 && Tm<6) hp<-"wf" else
	if(Tm>=6 && Tm<12) hp<-"ctmf" else
	if(Tm>=12 && Tm<18) hp<-"wtdf" else
	if(Tm>=18 && Tm<=24) hp<-"sdf" else
	if(Tm>24) hp<-"vdf"} else

if(Pm>=1000 && Pm<2000){
	if(Tm>=3 && Tm<6) hp<-"rf" else
	if(Tm>=6 && Tm<12) hp<-"ctwf" else
	if(Tm>=12 && Tm<18) hp<-"wtmf" else
	if(Tm>=18 && Tm<=24) hp<-"smf" else
	if(Tm>24) hp<-"tdf"} else

if(Pm>=2000 && Pm<4000){
	if(Tm>=6 && Tm<12) hp<-"ctrf" else
	if(Tm>=12 && Tm<18) hp<-"wtwf" else
	if(Tm>=18 && Tm<=24) hp<-"swf" else
	if(Tm>24) hp<-"tmf"} else

if(Pm>=4000 && Pm<8000){
	if(Tm>=12 && Tm<18) hp<-"wtrf" else
	if(Tm>=18 && Tm<=24) hp<-"srf" else
	if(Tm>24) hp<-"twf"} else
if(Pm>=8000 && Tm>=24) hp<-"trf" else hp<-"nothing"}

#Denominación en inglés
if(lang=="en"){
if(hp=="nothing") Hold<-"Nothing" else
if(hp=="po") Hold<-"Polar" else
if(hp=="dt") Hold<-"Dry tundra" else
if(hp=="bd") Hold<-"Boreal desert" else
if(hp=="ctd") Hold<-"Cool temperate desert" else
if(hp=="wtd") Hold<-"Warm temperate desert" else
if(hp=="sd") Hold<-"Subtropical desert" else
if(hp=="td") Hold<-"Tropical desert" else
if(hp=="mt") Hold<-"Moist tundra" else
if(hp=="ds") Hold<-"Dry Scrub" else
if(hp=="ctds") Hold<-"Cool temperate desert scrub" else
if(hp=="wtds") Hold<-"Warm temperate desert scrub" else
if(hp=="sds") Hold<-"Subtropical desert scrub" else
if(hp=="tds") Hold<-"Tropical desert scrub" else
if(hp=="wt") Hold<-"Wet tundra" else
if(hp=="mf") Hold<-"Moist forest" else
if(hp=="ste") Hold<-"Steppe" else
if(hp=="tste") Hold<-"Thorn steppe" else
if(hp=="stw") Hold<-"Subtropical thorn woodland" else
if(hp=="ttw") Hold<-"Tropical thorn woodland" else
if(hp=="rt") Hold<-"Rain tundra" else
if(hp=="wf") Hold<-"Wet forest (paramo)" else
if(hp=="ctmf") Hold<-"Cool temperate moist forest" else
if(hp=="wtdf") Hold<-"Warm temperate moist forest" else
if(hp=="sdf") Hold<-"Subtropical dry forest" else
if(hp=="vdf") Hold<-"Very dry tropical forest" else
if(hp=="rf") Hold<-"Rain forest" else
if(hp=="ctwf") Hold<-"Cool temperate wet forest" else
if(hp=="wtmf") Hold<-"Warm temperate moist forest" else
if(hp=="smf") Hold<-"Subtropical moist forest" else 
if(hp=="tdf") Hold<-"Tropical dry forest" else
if(hp=="ctrf") Hold<-"Cool temperate rainforest" else
if(hp=="wtwf") Hold<-"Warm temperate wet forest" else
if(hp=="swf") Hold<-"Subtropical wet forest" else
if(hp=="tmf") Hold<-"Tropical moist forest" else
if(hp=="wtrf") Hold<-"Warm temperate rainforest" else
if(hp=="srf") Hold<-"Subtropical rainforest" else
if(hp=="twf") Hold<-"Tropical wet forest"
if(hp=="trf") Hold<-"Tropical rainforest"}

else {if(lang=="es")#Denominación en castellano

if(hp=="nothing") Hold<-"Ni modo" else
if(hp=="po") Hold<-"Polar" else
if(hp=="dt") Hold<-"Tundra seca" else
if(hp=="bd") Hold<-"Desierto boreal" else
if(hp=="ctd") Hold<-"Desierto fr\\'io templado" else
if(hp=="wtd") Hold<-"Desierto c\\'alido templado" else
if(hp=="sd") Hold<-"Desierto subtropical" else
if(hp=="td") Hold<-"Desierto tropical" else
if(hp=="mt") Hold<-"Tundra h\\'umeda" else
if(hp=="ds") Hold<-"Matorral seco" else
if(hp=="ctds") Hold<-"Desierto fr\\'io templado de matorral" else
if(hp=="wtds") Hold<-"Desierto c\\'alido templado de arbustos" else
if(hp=="sds") Hold<-"Desierto subtropical de arbustos" else
if(hp=="tds")Hold<-"Desierto tropical de arbustos" else
if(hp=="wt") Hold<-"Tundra muy h\\'umeda" else
if(hp=="mf") Hold<-"Bosque h\\'umedo" else
if(hp=="ste") Hold<-"Estepa" else
if(hp=="tste") Hold="Estepa espinosa" else
if(hp=="stw") Hold<-"Matorral subtropical espinoso" else
if(hp=="ttw") Hold<-"Matorral tropical espinoso" else
if(hp=="rt") Hold<-"Tundra pluvial" else
if(hp=="wf") Hold<-"Bosque muy h\\'umedo (p\\'aramo)" else
if(hp=="ctmf") Hold<-"Bosque h\\'umedo templado fr\\'io" else
if(hp=="wtdf") Hold<-"Bosque h\\'umedo templado c\\'alido" else
if(hp=="sdf") Hold<-"Bosque seco subtropical" else
if(hp=="vdf") Hold<-"Bosque tropical muy seco" else
if(hp=="rf") Hold<-"Bosque pluvial" else
if(hp=="ctwf") Hold<-"Bosque muy h\\'umedo templado frío" else
if(hp=="wtmf") Hold<-"Bosque h\\'umedo templado c\\'alido" else
if(hp=="smf") Hold<-"Bosque subtropical h\\'umedo" else
if(hp=="tdf") Hold<-"Bosque tropical seco" else
if(hp=="ctrf") Hold<-"Bosque pluvial templado fr\\'io" else
if(hp=="wtwf") Hold<-"Bosque muy h\\'umedo templado c\\'alido" else
if(hp=="swf") Hold<-"Bosque subtropical muy h\\'umedo" else
if(hp=="tmf") Hold<-"Bosque h\\'umedo tropical" else
if(hp=="wtrf") Hold<-"Bosque pluvial templado c\\'alido" else
if(hp=="srf") Hold<-"Bosque pluvial subtropical" else
if(hp=="twf") Hold="Bosque tropical muy h\\'umedo" else
if(hp=="trf") Hold<-"Bosque pluvial tropical"}


######################Cálculo del Índice de Martonne##########################
IMar="" #Variable que incluirá el valor del índice de Martonne, la ponemos a cero
CMar="" #Variable para la clasificación bioclimática de Martonne, la ponemos a cero
IMar=round((Pm/(Tm+10)),digits=1) #Ya tenemos calculado el índice, redondeado

#Ahora unos bucles para las calificaciones bioclimáticas de acuerdo con el índice
if (lang=="es") { #Si el idioma es el por defecto, castellano
if(IMar<5) CMar<-"Desierto" else
if(IMar>=5 && IMar<10) CMar<-"Estepa des\\'ertica" else
if(IMar>=10 && IMar<20) CMar<-"Semi\\'arido" else
if(IMar>=20 && IMar<30) CMar<-"Subh\\'umedo" else
if(IMar>=30 && IMar<60) CMar<-"H\\'umedo" else CMar<-"Perh\\'umedo"} else

if (lang=="en"){ #hemos dado en la entrada el lenguaje en inglés
if(IMar<5) CMar<-"Desert" else
if(IMar>=5 && IMar<10) CMar<-"Desertic steppe" else
if(IMar>=10 && IMar<20) CMar<-"Semiarid" else
if(IMar>=20 && IMar<30) CMar<-"Subhumid" else
if(IMar>=30 && IMar<60) CMar<-"Humid" else CMar<-"Perhumid"}


############Clasificación de Köppen
#Calculamos las variables a utilizar para Köppen

tc<- min(tm) #Temperatura media del mes más frío en ºC
tw<- max(tm) #Temperatura media del mes más cálido en ºC
Tm<- sum(tm)/12 #Temperatura media anual ºC
Pm<- sum(pm) #Precipitación media anual en milímetros
Pa<- sum(pm)/10 #Precipitación media anual en centímetros
pd<- min(pm)/10 #Precipitación del mes más seco en centímetros
pw<- max(pm)/10 #Precipitación del mes más húmedo en centímetros

#Meses más húmedos y secos de invierno y de verano
phw<-max(pm[1]:pm[3])
psw<-min(pm[1]:pm[3])
phs<-max(pm[7]:pm[9])
pss<-min(pm[7]:pm[9])


#tipo="" #Variable literal que contendrá el código y nombre con que se califica la estación según Köppen


#Clasificación de Köppen, ya tenemos todos los cálculos necesarios listos; empezamos los bucles para castellano
if(lang=="es"){
if(tw<10) { #Climas polares y glaciares
if(tw>=0) tipo<-"ET (Tundra)" else tipo<-"EF (Glacial)"} else # tw>10, vamos a los siguientes

if(tc<(-3)){ #Climas fríos o boreales
if(pw>10*pd) tipo<-"Dw (Boreal con invierno seco)" else tipo<-"Df (Boreal h\\'umedo)"} else #tc>-3

if(tc>18 && Pm>750){
if(pd>=60) tipo<-"Af (Pluviisilva tropical)" else
if(pd<60 && Pm>750 && Pm<1000) tipo<-"Aw (Sabana)" else
if(pd<40 && Pm>1000 && Pm<1500) tipo<-"Aw (Sabana)" else
if(pd<20 && Pm>1500 && Pm<2000) tipo<-"Aw (Sabana)" else
if(pd==0 && Pm>2000 && Pm<2500) tipo<-"Aw (Sabana)" else tipo<-"Am (Bosque monz\\'onico)"}
else {

if(Pa>=2*Tm-14){ #Templados y mediterráneos
if(psw<(1/10)*phs){
if(tw>22) tipo<-"Cwa (Subtropical monz\\'onico)" else tipo<-"Cwb (Tropical en altura)"
} else
if(psw>(1/10)*phs){
if(pss<40 || pss<(phw/3)) {
if(tw>22) tipo<-"Csa (Mediterr\\'aneo interior)" else tipo<-"Csb (Mediterr\\'aneo litoral)"} else 
{if(tw>22) tipo<-"Cfa (Subtropical h\\'umedo}" else tipo<-"Cf (Templado oce\\'anico)"}}}

else {#Pa<2T-14, desiertos y semidesiertos
if(Pa<Tm) tipo<-"BWs (Desierto con lluvia de invierno)" else
if(Pa<(Tm+7)) tipo<-"BWx (Desierto con lluvias irregulares)" else
if(Pa<(Tm+14)) tipo<-"BWw (Desierto con lluvia de verano)" else
if(Pa>Tm && Pa<2*Tm) tipo<-"BSs (Semidesierto con lluvia de invierno)" else
if(Pa>(Tm+14) && Pa<2*(Tm+14)) tipo<-"BSw (Semidesierto con lluvia de verano)" else tipo<-"BSx (semidesierto con lluvias irregulares)"}
}}

#Ahora en inglés
if(lang=="en"){
if(tw<10) { #Climas polares y glaciares
if(tw>=0) tipo<-"ET (Tundra)" else tipo<-"EF (Glacial)"} else # tw>10, vamos a los siguientes

if(tc<(-3)){ #Climas fríos o boreales
if(pw>10*pd) tipo<-"Dw (Boreal with dry winter)" else tipo<-"Df (Boreal humid)"} else #tc>-3

if(tc>18 && Pm>750){
if(pd>=60) tipo<-"Af (Tropical rainforest)" else
if(pd<60 && Pm>750 && Pm<1000) tipo<-"Aw (Sabana)" else
if(pd<40 && Pm>1000 && Pm<1500) tipo<-"Aw (Sabana)" else
if(pd<20 && Pm>1500 && Pm<2000) tipo<-"Aw (Sabana)" else
if(pd==0 && Pm>2000 && Pm<2500) tipo<-"Aw (Sabana)" else tipo<-"Am (Monsoon forest)"}
else {

if(Pa>=2*Tm-14){ #Templados y mediterráneos
if(psw<(1/10)*phs){
if(tw>22) tipo<-"Cwa (Subtropical monsoon)" else tipo<-"Cwb (Tropical upland)"
} else
if(psw>(1/10)*phs){
if(pss<40 || pss<(phw/3)) {
if(tw>22) tipo<-"Csa (Mediterranean interior)" else tipo<-"Csb (Mediterranean coastal)"} else 
{if(tw>22) tipo<-"Cfa (Subtropical humid}" else tipo<-"Cf (Temperate oceanic)"}}}


else {#Pa<2T-14, desiertos y semidesiertos
if(Pa<Tm) tipo<-"BWs (Desert with winter rain)" else
if(Pa<(Tm+7)) tipo<-"BWx (Desert with irregular rain)" else
if(Pa<(Tm+14)) tipo<-"BWw (Desert with summer rain)" else
if(Pa>Tm && Pa<2*Tm) tipo<-"BSs (Steppe with winter rain)" else
if(Pa>(Tm+14) && Pa<2*(Tm+14)) tipo<-"BSw (Steppe with summer rain)" else tipo<-"BSx (Steppe wit irregular rain)"}
}}





##########################################################################################
##########################################################################################
##########################################################################################
#Ahora tenemos la información suficiente para preparar el gráfico-cuadro resumen
if(lang=="en") titulo<-"Climatic classifications" else titulo<-"Clasificaciones clim\\'aticas"

plot.new()
#Título e información de la localidad
if(hem==1) z<-"N" else z<-"S"
mtext(titulo,line=1,adj=0.5,font=2,cex=1.5,col="red")
text(-0.04,1,paste("",est," [",alt," m]"),adj=0,col="blue",font=2)
text(-0.04,0.95,paste(" Lat.: ",lat1,"\\de ",lat2,"'  Long.:  ",long1,"\\de ",long2,"'",z),adj=0,col="blue",font=2)

#Línea doble superior
abline(0.9,0,col="blue")
abline(0.89,0,col="blue")

#Línea discontínua de separación
abline(0.8,0,col="blue",lty=6)

#Clasificaciones
text(0.40,0.70,paste("Lang= " ,ILang,", ",CLang,sep=""))
text(0.40,0.65,paste("Martonne= ",IMar,", ",CMar,sep=""))
text(0.40,0.60,paste("Dantin & Revenga= ",IDR,", ",CDR,sep=""))
text(0.40,0.55,paste("Holdridge= " ,Hold,".",sep=""))
text(0.40,0.50,paste("K\\:ooppen= " ,tipo,".",sep=""))

#Línea discontínua inferior
abline(0.16,0,col="blue",lty=6)

#Doble línea final
abline(0.09,0,col="blue")
abline(0.08,0,col="blue")
}