##Diagrama de barras de precipitaciones mensuales
##Francisco Alcaraz Ariza (Murcia, Spain)

## Version 2.0 (16 de febrero de 2011)
#Correcciones menores

## Versión 1.2 (21 agosto 2009)
#Cambios desde la 1.1
#Añadidos rótulos a cada barra con la precipitación media
#Version 1.1
pmbar<- function(file,lang="es",margen=c(4,4,5,4),mlab="",pcol="#005ac8", tcol="#e81800", pfcol="cyan",sfcol="#0eb6d7",shem=FALSE) {
par(mar=margen,pty="s",las=1,new=FALSE,family="sans")
par(family="HersheySans")
#Limpiamos dat y loc de memoria por si se hubieran cargado con anterioridad
#if(exists("dat")) rm(dat)
#if(exists("loc")) rm(loc)
#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
old.par<-par(no.readonly=TRUE)
on.exit(par(old.par))

#etiquetas de los meses
if(lang=="en") mlab=c("J","F","M","A","M","J","J","A","S","O","N","D")
else mlab=c("E","F","M","A","M","J","J","A","S","O","N","D")
if(lang=="en") titulo="Monthly precipitations distribution"
else titulo="Distribuci\\'on mensual de precipitaciones"
hem=loc[1,7]
if(hem=="2") shem=TRUE 
else shem=FALSE
if(shem) {#Hemisferio sur: desplazar los datos medio año
m1 <- dat[1:6,]
m2 <- dat[7:12,]
dat<-rbind(m2,m1)
mlab<-c(mlab[7:12],mlab[1:6])
}
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

if((max(pm)>1500)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+500))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+100),pm[i],adj=0,font=2,cex=0.8)}} else

if((max(pm)>1000) && (max(pm)<=1500)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+200))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+50),pm[i],adj=0,font=2,cex=0.8)}} else


if((max(pm)>100) && (max(pm)<=1000)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+200))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+30),pm[i],adj=0,font=2,cex=0.8)}} else

if((max(pm)<=100) && (max(pm)>10)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+20))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+2),pm[i],adj=0,font=2,cex=0.8)}} else

if((max(pm)<=10) && (max(pm)>1)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+20))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+2),pm[i],adj=0,font=2,cex=0.8)}} else

if((max(pm)<1)){
barplot(pm,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pm)+20))
for(i in 1:12){
text(0.35+((i-1)*1.2),(pm[i]+0.5),pm[i],adj=0,font=2,cex=0.8)}}

abline(0,0)
mtext(paste(est," (",alt," m)"),line=0.5,adj=0.5)

}