##Diagrama de barras de precipitaciones estacionales
##Francisco Alcaraz Ariza (Murcia, Spain)

##Versión 2.0, 16 de febrero de 2011
#Arreglados problemas en layout cuando viene de pmbar

##Versión 1.2, 21 de agosto de 2009
psbar <-function(file,lang="es",shem=FALSE) {
par(family="HersheySans")
plot.new()
#Limpiamos dat y loc de memoria por si se hubieran cargado con anterioridad
#if(exists("dat")) rm(dat)
#if(exists("loc")) rm(loc)
#if(exists("pms")) rm(pms)
#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
#etiquetas de las estaciones
if(lang=="en") mlab=c("Winter","Spring","Summer","Automn")
else mlab=c("Invierno","Primavera","Verano","Otoño")
if(lang=="en") titulo="Seasonaly precipitations distribution (%)"
else titulo="Distribuci\\'on estacional de precipitaciones (%)"
hem=loc[1,7]
if(hem=="2") shem=TRUE 
else shem=FALSE
if(shem) {#Hemisferio sur: desplazar los datos medio año
m1 <- dat[1:6,]
m2 <- dat[7:12,]
dat<-rbind(m2,m1)
#mlab<-c(mlab[3:4],mlab[1:2])
}
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

#Calculamos la precipitación total, la estacional y el porcentaje
Pm<-sum(pm)
pms<-1:4
pms[1]<-((sum(pm[1],pm[2],pm[3]))*100)/Pm
pms[2]<-((sum(pm[4],pm[5],pm[6]))*100)/Pm
pms[3]<-((sum(pm[7],pm[8],pm[9]))*100)/Pm
pms[4]<-((sum(pm[10],pm[11],pm[12]))*100)/Pm
barplot(pms,col="red",border="dark blue",names.arg=mlab,main=titulo,ylim=c(0,max(pms)+10))
for(i in 1:4){
text(0.6+((i-1)*1.2),(pms[i]+2),paste(round(pms[i],digit=2),"%"),adj=0,font=2,cex=1.2)}

abline(0,0)
mtext(paste(est,"(",alt," m)"),line=0.5,adj=0.5)
}