##Cuadro resumen de datos, incluyendo la etp calculada
##Francisco Alcaraz Ariza (Murcia, Spain)

#version 1.5
resumen<-function(file,lang="es",margen=c(4,4,5,4),shem=FALSE) {
plot.new()
par(mar=margen,pty="s",las=1,new=FALSE,family="HersheySans")
#################################################
#Gestión de errores en la lectura de los ficheros
#nr<-nrow(dat) #número de filas de datos mensuales
#if(nrow(dat) <4) {cat("4 rows of monthly data must be provided\n");break; }
# #Limpiamos dat y loc de memoria por si se hubieran cargado con anterioridad
#if(exists("dat")) rm(dat)
#if(exists("loc")) rm(loc)

#Creamos las variables que vamos a utilizar
f<-1:12; e<-1:12; s<-1:12; Lr<-0;etp<-1:12;Etp<-0;latitud<-0
for(i in 1:12)
{f[i]<-0; e[i]<-0;s[i]<-0;etp[i]<-0;}

#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

nc<-ncol(dat) #Comprobamos el número de variables en dat
#Temperaturas medias mensuales
if(nc==4) {tm<-(tma+tmi)/2}
#En caso contrario es evidente que la segunda columna, interpretada por «attach» 
tm<-(tma+tmi)/2 #Calculamos la temperatura media mensual

##############################################################
############### Evapotranspiración potencial #################
##############################################################

#La latitud tiene dos componentes, lat1(grados), lat2(minutos), vamos a redondearla para hacer el cálculo, pues Thornwtwaite sólo usa los grados
if(lat2<=30) lat1->latitud else lat1+1->latitud 


#El componente «f» de la etp, sin fórmula, valores directos dependientes del hemisferio
if(hem=="2") shem=TRUE else shem=FALSE
if(shem) { #shem=TRUE, es decir, hemisferio es el sur
 if(latitud<5)
  {f[1]<-32.24;f[2]<-26.32;f[3]<-32.24;f[4]<-30.3;f[5]<-32.24;
  f[6]<-30.3;f[7]<-32.24;f[8]<-32.24;f[9]<-30.3;f[10]<-32.24;
  f[11]<-30.3;f[12]<-32.24} else
 if(5 <=latitud && latitud<10)
  {f[1]<-31*1.06;f[2]<-28*0.91;f[3]<-31*1.04;f[4]<-30*1.00;f[5]<-31*1.02;
  f[6]<-30*0.99;f[7]<-31*1.02;f[8]<-31*1.03;f[9]<-30*1.00;f[10]<-31*1.05;
  f[11]<-30*1.03;f[12]<-31*1.06} else
 if(10<=latitud && latitud<15)
  {f[1]<-31*1.08;f[2]<-28*0.97;f[3]<-31*1.05;f[4]<-30*0.99;f[5]<-31*1.01;
  f[6]<-30*0.96;f[7]<-31*1.00;f[8]<-31*1.01;f[9]<-30*1.00;f[10]<-31*1.06;
  f[11]<-30*1.05;f[12]<-31*1.10} else
 if(15<=latitud && latitud<20)
  {f[1]<-31*1.12;f[2]<-28*0.98;f[3]<-31*1.05;f[4]<-30*0.98;f[5]<-31*0.98;
  f[6]<-30*0.94;f[7]<-31*0.97;f[8]<-31*1.00;f[9]<-30*1.00;f[10]<-31*1.07;
  f[11]<-30*1.07;f[12]<-31*1.07} else
 if(20<=latitud && latitud<25)
  {f[1]<-31*1.14;f[2]<-28*1.00;f[3]<-31*1.05;f[4]<-30*0.97;f[5]<-31*0.96;
  f[6]<-30*0.91;f[7]<-31*0.95;f[8]<-31*0.99;f[9]<-30*1.00;f[10]<-31*1.08;
  f[11]<-30*1.09;f[12]<-31*1.15} else
 if(25<=latitud && latitud<30)
  {f[1]<-31*1.17;f[2]<-28*1.01;f[3]<-31*1.05;f[4]<-30*0.96;f[5]<-31*0.94;
  f[6]<-30*0.88;f[7]<-31*0.93;f[8]<-31*0.98;f[9]<-30*1.00;f[10]<-31*1.10;
  f[11]<-30*1.11;f[12]<-31*1.18} else
 if(30<=latitud && latitud<35)
  {f[1]<-31*1.20;f[2]<-28*1.03;f[3]<-31*1.06;f[4]<-30*0.95;f[5]<-31*0.92;
  f[6]<-30*0.85;f[7]<-31*0.90;f[8]<-31*0.96;f[9]<-30*1.00;f[10]<-31*1.12;
  f[11]<-30*1.14;f[12]<-31*1.21} else
 if(35<=latitud && latitud<40)
  {f[1]<-31*1.23;f[2]<-28*1.04;f[3]<-31*1.06;f[4]<-30*0.94;f[5]<-31*0.89;
  f[6]<-30*0.82;f[7]<-31*0.87;f[8]<-31*0.94;f[9]<-30*1.00;f[10]<-31*1.13; 
  f[11]<-30*1.17;f[12]<-31*1.25} else
 if(40<=latitud && latitud<42)
  {f[1]<-31*1.27;f[2]<-28*1.06;f[3]<-31*1.07;f[4]<-30*0.93;f[5]<-31*0.86;
  f[6]<-30*0.78;f[7]<-31*0.84;f[8]<-31*0.92;f[9]<-30*1.00;f[10]<-31*1.15;
  f[11]<-30*1.20;f[12]<-31*1.29} else
 if(42<=latitud && latitud<44)
  {f[1]<-31*1.28;f[2]<-28*1.07;f[3]<-31*1.07;f[4]<-30*0.92;f[5]<-31*0.85;
  f[6]<-30*0.76;f[7]<-31*0.82;f[8]<-31*0.92;f[9]<-30*1.00;f[10]<-31*1.16;
  f[11]<-30*1.22;f[12]<-31*1.31} else
 if(44<=latitud && latitud<46)
  {f[1]<-31*1.30;f[2]<-28*1.08;f[3]<-31*1.07;f[4]<-30*0.92;f[5]<-31*0.83;
  f[6]<-30*0.74;f[7]<-31*0.81;f[8]<-31*0.91;f[9]<-30*0.99;f[10]<-31*1.17;
  f[11]<-30*1.23;f[12]<-31*1.33} else
 if(46<=latitud && latitud<48)
  {f[1]<-31*1.32;f[2]<-28*1.10;f[3]<-31*1.07;f[4]<-30*0.91;f[5]<-31*0.82;
  f[6]<-30*0.72;f[7]<-31*0.79;f[8]<-31*0.90;f[9]<-30*0.99;f[10]<-31*1.17;
  f[11]<-30*1.25;f[12]<-31*1.35} else
 if(48<=latitud && latitud<50)
  {f[1]<-31*1.34;f[2]<-28*1.11;f[3]<-31*1.08;f[4]<-30*0.90;f[5]<-31*0.80;
  f[6]<-30*0.70;f[7]<-31*0.76;f[8]<-31*0.89;f[9]<-30*0.99;f[10]<-31*1.18;
  f[11]<-30*1.27;f[12]<-31*1.37} else
 if(latitud>=50)
  {f[1]<-42.47;f[2]<-30.8;f[3]<-33.48;f[4]<-26.7;f[5]<-23.87;
  f[6]<-20.1;f[7]<-22.94;f[8]<-27.28;f[9]<-29.7;f[10]<-36.98;
  f[11]<-38.7;f[12]<-43.71}}

else #shem=FALSE, estamos en el hemisferio norte
 if(latitud<5) 
   {f[1]<-32.24;f[2]<-26.32;f[3]<-32.24;f[4]<-30.3;f[5]<-32.24;f[6]<-30.3;
   f[7]<-32.24;f[8]<-32.24;f[9]<-30.3;f[10]<-32.24;f[11]<-30.3;f[12]<-32.24} else
 if(5<=latitud && latitud<10)
   {f[1]<-31.62;f[2]<-26.04;f[3]<-31.93;f[4]<-30.6;f[5]<-32.86;f[6]<-30.9;
   f[7]<-32.86;f[8]<-32.55;f[9]<-30.3;f[10]<-31.93;f[11]<-29.7;f[12]<-31.62} else
 if(10<=latitud && latitud<15)
   {f[1]<-31.00;f[2]<-25.48;f[3]<-31.93;f[4]<-30.90;f[5]<-33.48;f[6]<-31.80;
   f[7]<-33.48;f[8]<-33.17;f[9]<-30.6;f[10]<-31.62;f[11]<-29.4;f[12]<-30.69} else
 if(15<=latitud && latitud<20)
   {f[1]<-30.07;f[2]<-25.48;f[3]<-31.93;f[4]<-31.2;f[5]<-34.41;f[6]<-32.4;
   f[7]<-32.72;f[8]<-33.48;f[9]<-30.6;f[10]<-31.31;f[11]<-28.5;f[12]<-30.07} else
 if(20<=latitud && latitud<25)
   {f[1]<-29.45;f[2]<-25.2;f[3]<-31.93;f[4]<-31.5;f[5]<-35.03;f[6]<-33.30;
   f[7]<-35.34;f[8]<-34.41;f[9]<-30.6;f[10]<-31;f[11]<-27.9;f[12]<-29.14} else
 if(latitud==25)
   {f[1]<-27.9;f[2]<-26.7;f[3]<-30.9;f[4]<-31.8;f[5]<-34.5;f[6]<-34.2;
   f[7]<-35.1;f[8]<-33.6;f[9]<-30.6;f[10]<-29.7;f[11]<-27.3;f[12]<-27.3} else
 if(latitud==26)
   {f[1]<-27.6;f[2]<-26.4;f[3]<-30.9;f[4]<-32.1;f[5]<-34.8;f[6]<-34.5;
   f[7]<-35.1;f[8]<-33.6;f[9]<-30.6;f[10]<-29.7;f[11]<-27.3;f[12]<-27.3} else
 if(latitud==27)
   {f[1]<-27.6;f[2]<-26.4;f[3]<-30.9;f[4]<-32.1;f[5]<-34.8;f[6]<-34.5;
   f[7]<-35.4;f[8]<-33.9;f[9]<-30.6;f[10]<-29.7;f[11]<-27.0;f[12]<-27.0} else
 if(latitud==28)
   {f[1]<-27.3;f[2]<-26.4;f[3]<-30.9;f[4]<-32.1;f[5]<-35.1;f[6]<-34.8;
   f[7]<-35.4;f[8]<-33.9;f[9]<-30.9;f[10]<-29.4;f[11]<-27.0;f[12]<-27.0} else
 if(latitud==29)
   {f[1]<-27.3;f[2]<-26.1;f[3]<-30.9;f[4]<-32.1;f[5]<-35.1;f[6]<-34.8;
   f[7]<-35.7;f[8]<-33.9;f[9]<-30.9;f[10]<-29.4;f[11]<-26.7;f[12]<-26.7} else
 if(latitud==30)
   {f[1]<-27.0;f[2]<-26.1;f[3]<-30.9;f[4]<-32.4;f[5]<-35.4;f[6]<-35.1;
   f[7]<-36.0;f[8]<-34.2;f[9]<-30.9;f[10]<-29.4;f[11]<-26.7;f[12]<-26.4} else
 if(latitud==31)
   {f[1]<-27;f[2]<-26.1;f[3]<-30.9;f[4]<-32.4;f[5]<-35.4;f[6]<-35.1;
   f[7]<-36;f[8]<-34.2;f[9]<-30.9;f[10]<-29.4;f[11]<-26.4;f[12]<-26.4} else
 if(latitud==32)
   {f[1]<-26.7;f[2]<-25.8;f[3]<-30.9;f[4]<-32.4;f[5]<-35.7;f[6]<-35.4;
   f[7]<-36.3;f[8]<-34.5;f[9]<-30.9;f[10]<-29.4;f[11]<-26.4;f[12]<-26.1} else
 if(latitud==33)
   {f[1]<-26.4;f[2]<-25.8;f[3]<-30.9;f[4]<-32.7;f[5]<-35.7;f[6]<-35.7;
   f[7]<-36.3;f[8]<-34.5;f[9]<-30.9;f[10]<-29.1;f[11]<-26.1;f[12]<-25.8} else
 if(latitud==34)
   {f[1]<-26.4;f[2]<-25.8;f[3]<-30.9;f[4]<-32.7;f[5]<-36;f[6]<-36;
   f[7]<-36.6;f[8]<-34.8;f[9]<-30.9;f[10]<-29.1;f[11]<-26.1;f[12]<-25.8} else
 if(latitud==35)
   {f[1]<-26.1;f[2]<-25.5;f[3]<-30.9;f[4]<-32.7;f[5]<-36.3;f[6]<-36.3;
   f[7]<-36.9;f[8]<-34.8;f[9]<-30.9;f[10]<-29.1;f[11]<-25.8;f[12]<-25.5} else
 if(latitud==36)
   {f[1]<-26.1;f[2]<-25.5;f[3]<-30.9;f[4]<-33;f[5]<-36.3;f[6]<-36.6;
   f[7]<-37.2;f[8]<-34.8;f[9]<-30.9;f[10]<-29.1;f[11]<-25.8;f[12]<-25.2} else
 if(latitud==37)
   {f[1]<-25.8;f[2]<-25.5;f[3]<-30.9;f[4]<-33.0;f[5]<-36.6;f[6]<-36.9;
   f[7]<-37.5;f[8]<-35.1;f[9]<-30.9;f[10]<-29.1;f[11]<-25.5;f[12]<-24.9} else
 if(latitud==38)
   {f[1]<-25.5;f[2]<-25.2;f[3]<-30.9;f[4]<-33;f[5]<-36.9;f[6]<-37.2;
   f[7]<-37.5;f[8]<-35.1;f[9]<-31.2;f[10]<-28.8;f[11]<-25.2;f[12]<-24.9} else
 if(latitud==39)
   {f[1]<-25.5;f[2]<-25.2;f[3]<-30.9;f[4]<-33.3;f[5]<-36.9;f[6]<-37.2;
   f[7]<-37.8;f[8]<-35.4;f[9]<-31.2;f[10]<-28.8;f[11]<-25.2;f[12]<-24.6} else
 if(latitud==40)
   {f[1]<-25.2;f[2]<-24.9;f[3]<-30.9;f[4]<-33.3;f[5]<-37.2;f[6]<-37.5;
   f[7]<-38.1;f[8]<-35.4;f[9]<-31.2;f[10]<-28.8;f[11]<-24.9;f[12]<-24.3} else
 if(latitud==41)
   {f[1]<-24.9;f[2]<-24.9;f[3]<-30.9;f[4]<-33.3;f[5]<-37.5;f[6]<-37.8;
   f[7]<-38.1;f[8]<-35.7;f[9]<-31.2;f[10]<-28.8;f[11]<-24.6;f[12]<-24.0} else
 if(latitud==42)
   {f[1]<-24.6;f[2]<-24.6;f[3]<-30.9;f[4]<-33.6;f[5]<-37.8;f[6]<-38.1;
   f[7]<-38.4;f[8]<-35.7;f[9]<-31.2;f[10]<-28.5;f[11]<-24.6;f[12]<-23.7} else
 if(latitud==43)
   {f[1]<-24.3;f[2]<-24.6;f[3]<-30.6;f[4]<-33.6;f[5]<-37.8;f[6]<-38.4;
   f[7]<-38.7;f[8]<-36;f[9]<-31.2;f[10]<-28.5;f[11]<-24.3;f[12]<-23.1} else
 if(latitud==44)
   {f[1]<-0.81*31;f[2]<-0.82*28;f[3]<-1.02*31;f[4]<-1.13*30;f[5]<-1.27*31;
   f[6]<-1.29*30;f[7]<-1.30*31;f[8]<-1.20*31;f[9]<-1.04*30;f[10]<-0.95*31;
   f[11]<-0.8*30;f[12]<-0.76*31} else
 if(latitud==45)
   {f[1]<-0.8*31;f[2]<-0.81*28;f[3]<-1.02*31;f[4]<-1.13*30;f[5]<-1.28*31;
   f[6]<-1.29*30;f[7]<-1.31*31;f[8]<-1.21*31;f[9]<-1.04*30;f[10]<-0.94*31;
   f[11]<-0.79*30;f[12]<-0.75*31} else
 if(latitud==46)
   {f[1]<-0.79*31;f[2]<-0.81*28;f[3]<-1.02*31;f[4]<-1.13*30;f[5]<-1.29*31;
   f[6]<-1.31*30;f[7]<-1.32*31;f[8]<-1.22*31;f[9]<-1.04*30;f[10]<-0.94*31;
   f[11]<-0.79*30;f[12]<-0.74*31} else
 if(latitud==47)
   {f[1]<-0.77*31;f[2]<-0.8*28;f[3]<-1.02*31;f[4]<-1.14*30;f[5]<-1.3*31;
   f[6]<-1.32*30;f[7]<-1.33*31;f[8]<-1.22*31;f[9]<-1.04*30;f[10]<-0.93*31;
   f[11]<-0.78*30;f[12]<-0.73*31} else
 if(latitud==48)
   {f[1]<-0.76*31;f[2]<-0.8*28;f[3]<-1.02*31;f[4]<-1.14*30;f[5]<-1.31*31;
   f[6]<-1.33*30;f[7]<-1.34*31;f[8]<-1.23*31;f[9]<-1.05*30;f[10]<-0.93*31;
   f[11]<-0.77*30;f[12]<-0.72*31} else
 if(latitud==49)
   {f[1]<-0.75*31;f[2]<-0.79*28;f[3]<-1.02*31;f[4]<-1.14*30;f[5]<-1.32*31;
   f[6]<-1.34*30;f[7]<-1.35*31;f[8]<-1.24*31;f[9]<-1.05*30;f[10]<-0.93*31;
   f[11]<-0.76*30;f[12]<-0.71*31} else
 if(latitud>=50)
   {f[1]<-0.74*31;f[2]<-0.78*28;f[3]<-1.02*31;f[4]<-1.15*30;f[5]<-1.33*31;
   f[6]<-1.36*30;f[7]<-1.37*31;f[8]<-1.25*31;f[9]<-1.06*30;f[10]<-0.92*31;
   f[11]<-0.76*30;f[12]<-0.70*31}

### Vamos con los cálculos de la ETP según Thorntwaite ###
## Índice de calor mensual correspodiente a las temperaturas medias mensuales ##
 for(i in 1:12)
  {if(tm[i]<=0) (s[i]<-0) else s[i]<-(tm[i]/5)^1.514}
 for(i in 1:12)
  {Lr<-Lr+s[i]}
 ar<-(0.000000675*(Lr^3))-(0.0000771*(Lr^2))+(0.01792*Lr)+(0.49239)
## Ya tenemos todos los factores que necesitamos, pasamos a calcular «e»
 for(i in 1:12)
#Si la temperatura media del mes es igual o menor que cero, «e» es cero
  {if(tm[i]<=0) e[i]<-0 else
#Si va de más de cero hasta menos de 26.5, se calcula
  if(0<tm[i] && tm[i]<26.5) e[i]<-(1.6*((10*tm[i])/Lr)^ar) else
#A partir de 26.5 ºC el valor es directo
  if(tm[i]==26.5) e[i]<-13.50 else
  if(26.5<tm[i] && tm[i]<27.5) e[i]<-13.95 else
  if(27.5<=tm[i] && tm[i]<28) e[i]<-14.16 else
  if(28<=tm[i] && tm[i]<28.5) e[i]<-14.37 else
  if(28.5<=tm[i] && tm[i]<29) e[i]<-14.78 else
  if(29<=tm[i] && tm[i]<29.5) e[i]<-15.17 else
  if(29.5<=tm[i] && tm[i]<30) e[i]<-15.54 else
  if(30<=tm[i] && tm[i]<30.5) e[i]<-15.80 else
  if(30-5<=tm[i] && tm[i]<31) e[i]<-16.52 else
  if(31<=tm[i] && tm[i]<31.5) e[i]<-16.80 else
  if(31.5<=tm[i] && tm[i]<32) e[i]<-17.07 else
  if(32<=tm[i] && tm[i]<32.5) e[i]<-17.31 else
  if(32.5<=tm[i] && tm[i]<33) e[i]<-17.53 else
  if(33<=tm[i] && tm[i]<33.5) e[i]<-17.72 else
  if(33.5<=tm[i] && tm[i]<34) e[i]<-17.90 else
  if(34<=tm[i] && tm[i]<34.5) e[i]<-18.05}
# Sin más dilaciones, se procede ya al cálculo de la etp mensual y anual
 for(i in 1:12){
 if(tm[i]<=0) (etp[i]==0.0) else (etp[i]<-(f[i]*e[i])/3)}

#Ahora tenemos la información suficiente para preparar el gráfico-cuadro resumen
if(lang=="en") titulo="Data summary"
else titulo="Ficha resumen de datos"
if(lang=="en") total=" Year" else total=" Anual"
if(hem==1) z<-"N" else z<-"S"
Tm<-sum(tm)/12
Pm<-sum(pm)
Etp<-sum(etp)

m<-1:12 #Etiquetas para los meses
m[2]<-" F";m[3]<-" M";m[4]<-" A";m[5]<-" M";m[6]<-" J";m[7]<-" J";m[8]<-" A";m[9]<-" S";m[10]<-" O";m[11]<-" N";m[12]<-" D"
if(lang=="en") m[1]<-" J" else m[1]<-" E"
plot.new()

#Título e información de la localidad
if(hem==1) z<-"N" else z<-"S"
if(long3==1) zz<-"E" else zz<-"W"  
mtext(titulo,line=1,adj=0.5,font=2,cex=1.5,col="red")
text(-0.04,1,paste(est,"[",alt," m]"),adj=0,col="blue",font=2)
text(-0.04,0.95,paste(lat1,"\\de ",lat2,"' ",z,", ",long1,"\\de ",long2,"' ",zz,sep=""),adj=0,col="blue",font=2)


#Línea doble superior
abline(0.9,0,col="blue")
abline(0.89,0,col="blue")

#Etiquetas de las variables
if(nc==4){
text(0.20,0.85,"tma",adj=1,col="red",font=2)
text(0.40,0.85,"tmi",adj=1,col="red",font=2)
text(0.60,0.85,"tm",adj=1,col="red",font=2)
text(0.80,0.85,"pm",adj=1,col="red",font=2)
text(0.95,0.85,"etp",adj=1,col="red",font=2)}

else{
text(0.35,0.85,"tm",adj=1,col="red",font=2)
text(0.65,0.85,"pm",adj=1,col="red",font=2)
text(0.95,0.85,"etp",adj=1,col="red",font=2)}

#Línea discontínua de separación
abline(0.8,0,col="blue",lty=6)

#Ahora ponemos las columnas con etiquetas de meses y datos
for(i in 1:12){
text(0,0.80-(0.05*i),paste(m[i],"                 "),adj=0,font=2,col="red")
if(nc==4){
text(0.20,0.80-(0.05*i),format(tma[i],digits=1,nsmall=1),adj=1)
text(0.40,0.80-(0.05*i),format(tmi[i],digits=1,nsmall=1),adj=1)
text(0.60,0.80-(0.05*i),format(tm[i],digits=1,nsmall=1),adj=1)
text(0.80,0.80-(0.05*i),format(pm[i],digits=1,nsmall=1),adj=1)
text(0.95,0.80-(0.05*i),format(etp[i],digits=1,nsmall=1),adj=1)}

else
if(nc==2){
text(0.35,0.80-(0.05*i),format(tm[i],digits=1,nsmall=1),adj=1)
text(0.65,0.80-(0.05*i),format(pm[i],digits=1,nsmall=1),adj=1)
text(0.95,0.80-(0.05*i),format(etp[i],digits=1,nsmall=1),adj=1)
}}
#Línea discontínua inferior
abline(0.16,0,col="blue",lty=6)

#Totales finales
if(nc==4){
text(-0.04,0.12,total,adj=0,font=2,col="red")
text(0.60,0.12,round(Tm,digit=1),adj=1,font=2)
text(0.80,0.12,round(Pm,digit=1),adj=1,font=2)
text(0.95,0.12,round(Etp,digit=1),adj=1,font=2)}
else{
text(-0.04,0.12,total,adj=0,font=2,col="red")
text(0.35,0.12,round(Tm,digit=1),adj=1,font=2)
text(0.65,0.12,round(Pm,digit=1),adj=1,font=2)
text(0.95,0.12,round(Etp,digit=1),adj=1,font=2)}

#Doble línea final
abline(0.09,0,col="blue")
abline(0.08,0,col="blue")


}


