##Clasificación de Rivas Martínez
##Francisco Alcaraz Ariza (Murcia, Spain)

##Versión 1.0, 16 de febrero de 2011
#Cambios menores, probada ya lo suficiente

## Versión rc2 (27 de enero de 2010: 1283 líneas de código)

##Añadir rutina para poder poner si queremos la salida ya gráfica con cairoDevice
rivas<-function(file,lang="es",margen=c(2,1,5,2),mlab="",pcol="#005ac8", tcol="#e81800", pfcol="cyan",sfcol="red",shem=FALSE) { 
par(mar=margen,pty="s",las=1,new=FALSE,cex.main=1,family="HersheySans")

#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)


##Filtro para echar atrás estaciones sin datos de máximas y de mínimas
nc<-ncol(dat) #Comprobamos el número de variables en dat, sólo si hay cuatro columnas será posible seguir adelante

if(nc==2){
plot.new()

text(-0.0,0.85,paste("Fichero",est,", con sólo datos de medias"),adj=0,col="blue",font=2)
#text(-0.04,0.95,paste(" Lat.: ",lat1,"\\de ",lat2,"'  Long.:  ",long1,"\\de ",long2,"'",z),adj=0,col="blue",font=2)

#Línea doble superior
abline(0.9,0,col="blue")
abline(0.89,0,col="blue")

#Línea discontínua de separación
abline(0.8,0,col="blue",lty=6)

#Clasificaciones
#text(-0.04,0.12,total,adj=0,font=2,col="red")
#text(0.60,0.12,round(Tm,digit=1),adj=1,font=2)
text(0.50,0.70,paste("LO SIENTO"),adj=c(0.5,0),col="red",font=2,cex=0.6)
text(0.50,0.60,paste("NECESITA DATOS DE TEMPERATURAS MÁXIMAS Y M\\'INIMAS"),adj=c(0.5,0),col="red",font=2,cex=0.6) 
text(0.50,0.50,paste("PARA APLICAR ESTA FUNCIÓN"),adj=c(0.5,0),col="red",font=2,cex=0.6)

#Línea discontínua inferior
abline(0.16,0,col="blue",lty=6)

#Doble línea final
abline(0.09,0,col="blue")
abline(0.08,0,col="blue")}
else{#Se lanza la función, una vez detectado el fichero con cuatro columnas

################################################################
##INICIAMOS EL CÁLCULO DE LOS ÍNDICES QUE SE NECESITARÁN

##REFERENCIAS GEOGRÁFICAS
#Cinturas latitudinales (cint)
if((lat1>=0) && (lat1<7)) cint<-"ec"
if((lat1>=7) && (lat1<23)) cint<-"eutr"
if((lat1>=23) && (lat1<35)) cint<-"subtr"
if((lat1>=35) && (lat1<52)) cint<-"eut"
if((lat1>=52) && (lat1<66) && (hem==1)) cint<-"subts"
if((lat1>=52) && (lat1<60) && (hem==2)) cint<-"subta"
if((lat1>=66) && (hem==1)) cint="art"
if((lat1>=60) && (hem==2)) cint="anta"

##ÍNDICES TÉRMICOS
#Cálculo de las medias mensuales a partir de medias de máximas y mínimas
tm<-((tma+tmi)/2)
#Temperatura media anual (Tm)
Tm<-sum(tm)/12

#Extensiones de temperatura para cálculos con bucles, deben ponerse tras cálculo de las temperaturas medias
tm[13]<-tm[1]
tm[14]<-tm[2]
tm[15]<-tm[3]
tm[16]<-tm[4]
tm[17]<-tm[5]
tm[18]<-tm[6]
tm[19]<-tm[7]
tm[20]<-tm[8]
tm[21]<-tm[9]
tm[22]<-tm[10]
tm[23]<-tm[11]



#Temperatura media anual a 200 m (Tm200)

if(alt<=200) Tm200<-Tm else{
if((hem==1) && (lat1>23) && (lat1<=48) && (alt>200)) (Tm200<-(Tm + ((alt/100)*0.6))) else
if((hem==1) && (lat1>48) && (alt>200)) (Tm200<-(Tm + ((alt/100)*0.4))) else
if((hem==2) && (lat1>23) && (lat1<=51) && (alt>200)) (Tm200<-(Tm + ((alt/100)*0.6))) else
if((hem==2) && (lat1>51) && (alt>200)) (Tm200<-(Tm + ((alt/100)*0.4)))}

#Temperatura positiva anual en décimas de grado (Tp)
Tp<-0
for (i in 1:12)
{if(tm[i]>=0) Tp+(tm[i]*10)->Tp else Tp->Tp
}

#Temperatura negativa anual (Tn)
Tn<-0
for(i in 1:12){
if(tm[i]<0) Tn<-Tn-(tm[i]*10) else Tn<-Tn
}

#Temperatura media del trimestre estival (Ts)
Ts<-0
if(hem==1) for(i in 6:8){
if(tm[i]>0) Ts<-Ts+(tm[i]*10) else Ts<-Ts}

if(hem==2) (for(i in 12:14){
if(tm[i]>0) Ts<-Ts+(tm[i]*10) else Ts<-Ts})

#Temperatura positiva anual a 200 m (Tp200)
if(alt>200) {Tp200<-(Tp+((alt/100)*12))} else Tp200<-Tp

#Temperatura positiva del trimestre estival en décimas de grado (Tps)
if(hem==1)Tps<-(10*(tm[6]+tm[7]+tm[8])) else Tps<-(10*(tm[12]+tm[1]+tm[2]))

#Temperatura positiva del trimestre estival en décimas de grado a menos de 200 m (Tps200)
if(alt>200) Tps200<-(Tps+(alt/100)*0.6) else Tps200<-Tps

#Valores de interés para el mes más cálido del año
#Primero necesitamos establecer cuál es el mes más cálido del año (M)
M<-1
for (i in 1:11) 
{if (tm[M]>tm[i+1]) M<-M else {M<-(i+1)}}
#Temperatura media del mes más cálido es tm[M]

#Valores de interés para el mes más frío del año
#Primero necesitamos establecer cuál es el mes más frío del año (m)
#Por defecto empezamos suponiendo que el mes más frío es enero
m<-1
for (i in 2:12) {
if ((tm[m])<(tm[i])) m<-m else {m<-(i)}}

#Ahora vienen los cálculos de parámetros de este mes frío
#Temperatura media de las mínimas del mes más frío (tmf)
tmf<-tmi[m]

#Temperatura media de las máximas del mes más frío (tMf)
tMf<-tma[m]
##OJOOOOO
# Temperatura media de las mínimas del mes más frío m para 200 m en zonas por debajo de los paralelos 35 N y S (tmf200)
if(alt<200) tmf200<-tmf else{tmf200<-(tmf+((alt/100)*0.5))}

# Temperatura media de las máximas del mes más frío tMf para 200 m en zonas por debajo de los paralelos 35 N y S (tMf200)
if(alt<200) tMf200<-tMf else {tMf200<-(tMf+((alt/100)*0.5))}

  
#Íindice de diurnalidad (Id)
#tma-tmi del mes más contrastado del año
tma[1]-tmi[1]->Id
for(i in 2:12){
if((tma[i]-tmi[i])>Id) ((tma[i]-tmi[i])->Id) else Id<-Id
}

##CONTINENTALIDAD
#Índice de continentalidad simple o de amplitud térmica anual(Ic)
Ic=tm[M]-tm[m]

#Tipos de continentalidad (cont1)
if (Ic>=0 && Ic<=11) {cont1<-"ho"}
if (Ic>11 && Ic<=21) {cont1<-"o"}
if(Ic>21) {cont1<-"c"}
#Subtipos de continentalidad (continentalidad2)
if (Ic>=0 && Ic<=2) {cont2<-"uha"}
if (Ic>=2 && Ic<=4) {cont2<-"uht"}
if (Ic>4 && Ic<=6) {cont2<-"euha"}
if (Ic>6 && Ic<=8) {cont2<-"euht"}
if (Ic>8 && Ic<=10) {cont2<-"sbha"}
if (Ic>10 && Ic<=11) {cont2<-"sbht"}
if (Ic>11 && Ic<=13) {cont2<-"sha"}
if (Ic>13 && Ic<=14) {cont2<-"sht"}
if (Ic>14 && Ic<=16) {cont2<-"eoa"}
if (Ic>16 && Ic<=17) {cont2<-"eot"}
if (Ic>17 && Ic<=19) {cont2<-"sct"}
if (Ic>19 && Ic<=21) {cont2<-"sca"}
if (Ic>21 && Ic<=24) {cont2<-"sbct"}
if (Ic>24 && Ic<=28) {cont2<-"sbca"}
if (Ic>28 && Ic<=37) {cont2<-"ect"}
if (Ic>37 && Ic<=46) {cont2<-"eca"}
if (Ic>46 && Ic<=56) {cont2<-"hct"}
if (Ic>56 && Ic<=66) {cont2<-"hca"}

# Índice de termicidad
It<-((Tm+tmf+tMf)*10)

#Índice de termicidad compensado (zonas extratropicales de la tierra, por encima de los paralelos 23 N y S) (Itc), incluimos cálculo para <23º latitud
if(lat1<=23) Itc<-It else
if(lat1>23) { #Vamos a calcular el valor de compensación (C)
if(Ic<=8) Itc<-It-(10*(8-Ic)) #Zonas ultra y euhiperoceánicas
 else if(Ic>8 && Ic<=18) {Itc<-It}
   else if(Ic>18 && Ic<=21) {Itc<-It+(5*(Ic-18))} 
    else if(Ic>21 && Ic<=28) {Itc<-It+(15+(15*(Ic-21)))}
  else if(Ic>28 && Ic<=46) {Itc<-It+15+105+(25*(Ic-28))}
    else if(Ic>46 && Ic<=66) {Itc<-It+15+105+450+(30*(Ic-46))}
      else {Itc<-It}}

#Índice de termicidad para 200 m (Itc200)
if (alt>200) Itc200<-Itc+((alt/100)*13) else Itc200<-Itc


##ÍNDICES PLUVIOMÉTRICOS
#Precipitación media anual
Pm<-sum(pm)

#Extensión de p para los bucles
pm[13]<-pm[1]
pm[14]<-pm[2]
pm[15]<-pm[3]
pm[16]<-pm[4]
pm[17]<-pm[5]
pm[18]<-pm[6]
pm[19]<-pm[7]
pm[20]<-pm[8]
pm[21]<-pm[9]
pm[22]<-pm[10]
pm[23]<-pm[11]

#Precipitación de la estación seca (Pd), se usa en zonas tropicales, de los tres meses consecutivos más secos del año
Pd<-(pm[1]+pm[2]+pm[3])
for(i in 2:12){
if((pm[i]+pm[i+1]+pm[i+2])<Pd) Pd<-pm[i]+pm[i+1]+pm[i+2] else Pd<-Pd}

#Precipitaciones estival (Ps) e invernal (Pw)
#Hemisferio norte
if(hem==1) Ps<-pm[6]+pm[7]+pm[8]
if(hem==1) Pw<-pm[12]+pm[1]+pm[2]
#OJOOO En zonas de alta montaña y polares algunos meses estivales tienen tm<0 y habrá que usar precipitación positiva; eso está pendiente
#Hemisferio sur
if(hem==2) Pw<-pm[6]+pm[7]+pm[8]
if(hem==2) Ps<-pm[12]+pm[1]+pm[2]

##ÍNDICES TERMOPLUVIOMÉTRICOS
#Precipitación positiva anual (Pp)
Pp<-0
for(i in 1:12){
if(tm[i]>0) Pp<-Pp+pm[i] else Pp<-Pp
}

#Precipitación positiva mensual
#Creamos la variable
pp<-c(1:12)
#Ahora el bucle
for(i in 1:12){
if(tm[i]>0) (pp[i]<-pm[i]) else pp[i]<-0
}

#Índice ombrotérmico anual
if(Pp>0) Io<-(Pp/Tp)*10 else (Io<-"NO")

#Índice ombrotérmico del mes más cálido del trimestre estival (Ios1)
#Calculamos mes más cálido y paralelamente el Ios1
if(hem==1){
if((tm[6]>tm[7]) && (tm[6]>tm[8])) (Ios1<-pm[6]/(tm[6])) else
if((tm[7]>tm[8]) && (tm[7]>tm[6])) (Ios1<-pm[7]/(tm[7])) else (Ios1<-pm[8]/(tm[8]))
} else {
if((tm[12]>tm[1]) && (tm[12]>tm[2])) (Ios1<-pm[12]/(tm[12])) else
if((tm[1]>tm[2]) && (tm[1]>tm[12])) (Ios1<-pm[1]/(tm[1])) else (Ios1<-pm[2]/(tm[2]))
}

#Índice ombrotérmico del mes más seco del año (Iod1)
#Mes más seco del año (ms)
ms<-1
for(i in 2:12){
if((pm[ms])<(pm[i])) ms<-ms else ms<-i}
#Ahora hacemos el cálculo de Iod1
if(pm[ms]==0) Iod1<-"NO" else Iod1<-(pm[ms]/tm[ms])

#Índice ombrotérmico bimestral + seco del trimestre más seco del año
#Bimestre más seco del año
biseco<-(pm[1]+pm[2])
Iod2<-(pm[1]+pm[2])/(tm[1]+tm[2])
for(i in 2:12){
if((pm[i]+pm[i+1])<biseco) ((biseco<-pm[i]+pm[i+1]) && (Iod2<-biseco/(tm[i]+tm[i+1])) ) else ((Iod2<-Iod2) && (biseco<-biseco))
} 

if(biseco==0) Iod2<-"NO" else biseco<-biseco

#Índice ombrotérmico trimestral del trimestre más seco del año (Iod3)
triseco<-(pm[2]+pm[3]+pm[4])
cuatriseco<-(pm[1]+pm[2]+pm[3]+pm[4])
Iod3<-(pm[2]+pm[3]+pm[4])/(tm[2]+tm[3]+tm[4])
Iod4<-(pm[1]+pm[2]+pm[3]+pm[4])/(tm[1]+tm[2]+tm[3]+tm[4])
for(i in 3:13){
if((pm[i]+pm[i+1]+pm[i+2])<triseco) ((triseco<-pm[i]+pm[i+1]+pm[i+2]) && (cuatriseco<-pm[i-1]+pm[i]+pm[i+1]+pm[i+2]) && 
(Iod3<-triseco/(tm[i]+tm[i+1]+tm[i+2])) && (Iod4<-cuatriseco/(tm[i-1]+tm[i]+tm[i+1]+tm[i+2]))) else ((Iod3<-Iod3) && 
(triseco<-triseco) && (cuatriseco<-cuatriseco) && (Iod4<-Iod4))
}

if(triseco==0) Iod3<-"NO" else Iod3<-Iod3
if(cuatriseco==0) Iod4<-"NO" else Iod4<-Iod4

#Índice ombrotérmico trimestral del trimestre más seco del año (Iod3)
#triseco<-(pm[1]+pm[2]+pm[3])
#Iod3<-(pm[1]+pm[2]+pm[3])/(tm[1]+tm[2]+tm[3])
#for(i in 2:12){
#if((pm[i]+pm[i+1]+pm[i+2])<triseco) ((triseco<-pm[i]+pm[i+1]+pm[i+2]) && (Iod3<-triseco/(tm[i]+tm[i+1]+tm[i+2])) ) else ((Iod3<-Iod3) && 
#(triseco<-triseco))
#}

##Suma en décimas de grado de las temperaturas medias mensuales de los tres meses estivales 
#(junio + julio + agosto en norte; diciembre + enero + febrero en sur). 
#En tropical Td la de los tres meses consecutivos más secos del año.

#Trimestres anuales (Tr1, Tr2, Tr3, Tr4); Tr1
#Precipitaciones de los semestres más cálido (Ts1 Pss) y más frío (Ts2 Psw) de año
#Semestre + cálido y más frío del año
Sc<-(tm[1]+tm[2]+tm[3]+tm[4]+tm[5]+tm[6])
Sf<-(tm[7]+tm[8]+tm[9]+tm[10]+tm[11]+tm[12])
Pss<-(pm[1]+pm[2]+pm[3]+pm[4]+pm[5]+pm[6])
Psw<-(pm[7]+pm[8]+pm[9]+pm[10]+pm[11]+pm[12])
for(i in 2:12){
if((tm[i]+tm[i+1]+tm[i+2]+tm[i+3]+tm[i+4]+tm[i+5])>Sc) (((tm[i]+tm[i+1]+tm[i+2]+tm[i+3]+tm[i+4]+tm[i+5])->Sc) && 
(Pss<-pm[i]+pm[i+1]+pm[i+2]+pm[i+3]+pm[i+4]+pm[i+5]) && (Sf<-(tm[i+6]+tm[i+7]+tm[i+8]+tm[i+9]+tm[i+10]+tm[i+11])) && 
(Psw<-(pm[i+6]+pm[i+7]+pm[i+8]+pm[i+9]+pm[i+10]+pm[i+11]))) else ((Sc<-Sc) && (Sf<-Sf) && (Pss<-Pss) && (Psw<-Psw))
}

##Precipitación positiva invernal (Ppw)
##PENDIENTE

#Precipitación del cuatrimestre más cálido (Tc1) del año (Pcm1), del anterior (Pcm2) y del posterior (Pcm3)
#Calculamos cuál es el cuatrimestre más cálido del año y de paso los tres tipos de precipitación
Tc1<-sum(tm[1]:tm[4])
Pcm1<-sum(pm[1]:pm[4])
Pcm2<-sum(pm[9]:pm[12])
Pcm3<-sum(pm[5]:pm[8])
for (i in 2:12){
if((tm[i]+tm[i+1]+tm[i+2]+tm[i+3])>Tc1) {(Tc1<-(tm[i]+tm[i+1]+tm[i+2]+tm[i+3])) && (Pcm1<-(pm[i]+pm[i+1]+pm[i+2]+pm[i+3])) && 
(Pcm2<-(pm[i-4] + pm[i-3] + pm[i-2] + pm[i-1]))  && (Pcm3<-(pm[i+4] + pm[i+5] + pm[i+6] + pm[i+7]))} else {(Tc1<-Tc1) && (Pcm1<-Pcm1) && (Pcm2<-Pcm2) && (Pcm3<-Pcm3)}
}

#Índice ombrotérmico del bimestre más cálido del trimestre estival (Ios2)
#Tr3 trimestre correspondiente al solsticio de verano (estival)
#Calculamos cuáles son los dos meses más cálidos del verano y a partir de ellos el índice bimestral
#Primero para el caso de que estemos en el hemisferio norte

if(hem==1) {
if((tm[6]+tm[7])>(tm[7]+tm[8])) { 
if(pm[6]+pm[7]==0) Ios2<-"NO" else Ios2<-(pm[6]+pm[7])/(tm[6]+tm[7])} else {if(pm[7]+pm[8]==0) Ios2<-"NO" else Ios2<-(pm[7]+pm[8])/(tm[7]+tm[8])
}} else {#hemisferio sur
if((tm[12]+tm[1])>(tm[1]+tm[2])) {
if(pm[12]+pm[1]==0) Ios2<-"NO" else Ios2<-(pm[12]+pm[1])/(tm[12]+tm[1])} else {if(pm[1]+pm[2]==0) Ios2<-"NO" else Ios2<-(pm[1]+pm[2])/(tm[1]+tm[2])
}}

#Índices ombrotérmicos estivales resultado de la compensación (Iosc: Iosc3 & Iosc4)
#Ios3, los tres meses de verano
#Ios4, cuando contamos con el mes anterior al verano, mayo o noviembre

if(hem==1){
if((pm[6]+pm[7]+pm[8])==0) Iosc3<-"NO" else Iosc3<-((pm[6]+pm[7]+pm[8])/(tm[6]+tm[7]+tm[8]))
if((pm[5]+pm[6]+pm[7]+pm[8])==0) Iosc4="NO" else Iosc4<-((pm[5]+pm[6]+pm[7]+pm[8])/(tm[5]+tm[6]+tm[7]+tm[8]))
} else {#hemisferio sur
if(pm[12]+pm[1]+pm[2]==0) Iosc3<-"NO" else Iosc3<-(pm[12]+pm[1]+pm[2])/(tm[12]+tm[1]+tm[2])
if(pm[11]+pm[12]+pm[1]+pm[2]==0) Iosc4<-"NO" else Iosc4<-(pm[11]+pm[12]+pm[1]+pm[2])/(tm[11]+tm[12]+tm[1]+tm[2])
}

#Rutina de compensación para Mediterráneo -- Templado
#Comp=1: compensado; Comp=0: con compensado
if((Ios2>2) && (Ios2!="NO")) Comp<-1 else{
if(Io<2) Comp<-0 else{
if(Io>2 && Io<=2.8){
if(Ios2>=1.9 && Iosc3>=2.0 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>2.8 && Io<=3.6){
if(Ios2>=1.8 && Iosc3>=1.9 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>3.6 && Io<=4.8){
if(Ios2>=1.8 && Iosc3>=1.9 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>4.8 && Io<=6.0){
if(Ios2>=1.7 && Iosc3>=1.9 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>6.0 && Io<=7.0){
if(Ios2>=1.5 && Iosc3>=1.8 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>7.0 && Io<=8.0){
if(Ios2>=1.4 && Iosc3>=1.8 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>8.0 && Io<=9.0){
if(Ios2>=1.3 && Iosc3>=1.8 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>9.0 && Io<=10.0){
if(Ios2>=1.2 && Iosc3>=1.8 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>10.0 && Io<=11.0){
if(Ios2>=1.1 && Iosc3>=1.7 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>11.0 && Io<=12.0){
if(Ios2>=1.0 && Iosc3>=1.7 && Iosc4>=2.0) Comp<-1 else Comp<-0
}
if(Io>12){
if(Ios2>=0.9 && Iosc3>=1.7 && Iosc4>=2.0) Comp<-1 else Comp<-0
}}}
#if(Io<2) Comp<-0

##################################################################################################
##################################################################################################
##ENTRANDO EN LA CLASIFICACIÓN
##Cálculo de macrobioclimas
#Territorios intertropicales entre los paralelos 23N y 23S (cinturas ecuatorial y eutropical)
if(lat1<=23) mc<-"TR"
#######################################
#Territorios entre los paralelos 23--35 N y S (cintura subtropical)
if(lat1>23 && lat1<=35){
#Hiperdesiertos de ritmo Mediterráneo pero Pss>=Psw
if(Io<=0.4 && Pss>=(0.8*Psw)) mc<-"TR" else {
#Eurasia: 26 a 35 N, longitud 70 a 120 E, altitud = o mayor 2000 m
if(hem==1 && lat1>=26 && lat1<=35 && long3==1 && long1>=70 && long1<=120 && alt>=2000){
if(Comp==1) mc<-"T" else mc<-"M"}
else {
if(Tm200>=25 && tmf200>=10 || Tm200>=25 && Itc200>=580 || tmf200>=10 && Itc200>=580) {mc<-"TR"} 
 else {
if(Tm200>21 && tMf200>18 || Tm200>=21 && Itc200>=470 || tMf200>18 && Itc200>=470)
     if(Pss>Psw) mc<-"TR"
      else {
         if(Comp==1) mc <-"TR" else{if(Pcm3<Pcm1 && Pcm1>Pcm2) mc="TR" else mc<-"M" }}
         else {if(Comp==1) {mc<-"T"} else {mc<-"M"}}}}}}
######################################
#Territorios de latitud mayor de 35 (cinturas eutemplada, subtemplada y zona fría)
if(lat1>35){
if((hem==1 && lat1>72) || (hem==2 && lat1>56)) mc<-"P" else
if(Tp<380) mc<-"P" else {#Tp200>380
if (Ic<11 && Tps200<=290 && tm[M]<= 10) mc<-"B" else {
if(Ic<21 && Tm200<5.3 && Tp200<720 || Ic>=21 && Ic<=28 && Tm200<4.8 && Tp200<740 || Ic>28 && Tm200<3.8 && Tp200<800) mc<-"B" else {
if(Comp==1) mc<-"T" else mc<-"M"
}}}}
################################################################ Fin Determinación Macrobioclimas ###################################

########################### Pisos bioclimáticos ###########################
##Ya tenemos los macrobioclimas, ahora a por los termotipos
#Termotipos Tropicales
if(mc=="TR"){
#Horizontes termotípicos (ht) para luego traducir en horizontes en los gráficos
if((Ic<21) && (Itc>=120)){
if(Itc>800) ht<-"Itri"
if((Itc<=800) && (Itc>710)) ht<-"Itrs"
if((Itc<=710) && (Itc>600)) ht<-"Ttri"
if((Itc<=600) && (Itc>490)) ht<-"Ttrs"
if((Itc<=490) && (Itc>405)) ht<-"Mtri"
if((Itc<=405) && (Itc>320)) ht<-"Mtrs"
if((Itc<=320) && (Itc>240)) ht<-"Stri"
if((Itc<=240) && (Itc>160)) ht<-"Strs"
if((Itc<=160) && (Itc>=120)) ht<-"Otri"
} else{#O bien el Ic es mayor o igual de 21 o bien Itc<120 o ambos
if(Tp>3200) ht<-"Itri"
if((Tp<=3200) && (Tp>2900)) ht<-"Itrs"
if((Tp<=2900) && (Tp>2600)) ht<-"Ttri"
if((Tp<=2600) && (Tp>2300)) ht<-"Ttrs"
if((Tp<=2300) && (Tp>2000)) ht<-"Mtri"
if((Tp<=2000) && (Tp>1700)) ht<-"Mtrs"
if((Tp<=1700) && (Tp>1325)) ht<-"Stri"
if((Tp<=1325) && (Tp>950)) ht<-"Strs"
if((Tp<=950) && (Tp>700)) ht<-"Otri"
if((Tp<=700) && (Tp>450)) ht<-"Otrs"
if((Tp<=450) && (Tp>100)) ht<-"Ctri"
if((Tp<=100) && (Tp>0)) ht<-"Ctrs"
if(Tp==0) ht<-"G"
}
}

#Termotipos Mediterráneos
if(mc=="M"){
#Horizontes termotípicos (ht) para luego traducir en horizontes en los gráficos
if((Ic<21) && (Itc>=120)){
if(Itc>515) ht<-"Imei"
if((Itc<=515) && (Itc>450)) ht<-"Imes"
if((Itc<=450) && (Itc>400)) ht<-"Tmei"
if((Itc<=400) && (Itc>350)) ht<-"Tmes"
if((Itc<=350) && (Itc>285)) ht<-"Mmei"
if((Itc<=285) && (Itc>220)) ht<-"Mmes"
if((Itc<=220) && (Itc>150)) ht<-"Smei"
if((Itc<=150) && (Itc>=120)) ht<-"Smes"
} else{#O bien el Ic es mayor o igual de 21 o bien Itc<120 o ambos
if(Tp>2600) ht<-"Imei"
if((Tp<=2600) && (Tp>2400)) ht<-"Imes"
if((Tp<=2400) && (Tp>2250)) ht<-"Tmei"
if((Tp<=2250) && (Tp>2100)) ht<-"Tmes"
if((Tp<=2100) && (Tp>1800)) ht<-"Mmei"
if((Tp<=1800) && (Tp>1500)) ht<-"Mmes"
if((Tp<=1500) && (Tp>1200)) ht<-"Smei"
if((Tp<=1200) && (Tp>900)) ht<-"Smes"
if((Tp<=900) && (Tp>675)) ht<-"Omei"
if((Tp<=675) && (Tp>450)) ht<-"Omes"
if((Tp<=450) && (Tp>100)) ht<-"Cmei"
if((Tp<=100) && (Tp>0)) ht<-"Cmes"
if(Tp==0) ht<-"G"
}
}

#Termotipos Templados
if(mc=="T"){
#Horizontes termotípicos (ht) para luego traducir en horizontes en los gráficos
if((Ic<21) && (Itc>=120)){
if(Itc>410) ht<-"Ite"
if((Itc<=410) && (Itc>350)) ht<-"Ttei"
if((Itc<=350) && (Itc>290)) ht<-"Ttes"
if((Itc<=290) && (Itc>240)) ht<-"Mtei"
if((Itc<=240) && (Itc>190)) ht<-"Mtes"
if((Itc<=190) && (Itc>=120)) ht<-"Stei"
} else{#O bien el Ic es mayor o igual de 21 o bien Itc<120 o ambos
if(Tp>2350) ht<-"Ite"
if((Tp<=2350) && (Tp>2175)) ht<-"Ttei"
if((Tp<=2175) && (Tp>2000)) ht<-"Ttes"
if((Tp<=2000) && (Tp>1700)) ht<-"Mtei"
if((Tp<=1700) && (Tp>1400)) ht<-"Mtes"
if((Tp<=1400) && (Tp>1100)) ht<-"Stei"
if((Tp<=1100) && (Tp>800)) ht<-"Stes"
if((Tp<=800) && (Tp>590)) ht<-"Otei"
if((Tp<=590) && (Tp>380)) ht<-"Otes"
if((Tp<=380) && (Tp>100)) ht<-"Ctei"
if((Tp<=100) && (Tp>0)) ht<-"Ctes"
if(Tp==0) ht<-"G"
}
}

#Termotipos Boreales
#Aquí sólo se tiene en cuenta la temperatura positiva
if(mc=="B"){
#Horizontes termotípicos (ht) para luego traducir en horizontes en los gráficos
if(Tp>740) ht<-"Tboi"
if((Tp<=740) && (Tp>680)) ht<-"Tbos"
if((Tp<=680) && (Tp>630)) ht<-"Mboi"
if((Tp<=630) && (Tp>580)) ht<-"Mbos"
if((Tp<=580) && (Tp>530)) ht<-"Sboi"
if((Tp<=530) && (Tp>480)) ht<-"Sbos"
if((Tp<=480) && (Tp>430)) ht<-"Oboi"
if((Tp<=430) && (Tp>380)) ht<-"Obos"
if((Tp<=380) && (Tp>280)) ht<-"Cboi"
if((Tp<=280) && (Tp>100)) ht<-"Cbom"
if((Tp<=100) && (Tp>0)) ht<-"Cbos"
if(Tp==0) ht<-"G"
}

#Termotipos Polares
#Aquí sólo se tiene en cuenta la temperatura positiva
if(mc=="P"){
#Horizontes termotípicos (ht) para luego traducir en horizontes en los gráficos
if(Tp>330) ht<-"Tpoi"
if((Tp<=330) && (Tp>280)) ht<-"Tpos"
if((Tp<=280) && (Tp>190)) ht<-"Mpoi"
if((Tp<=190) && (Tp>100)) ht<-"Mpos"
if((Tp<=100) && (Tp>50)) ht<-"Spoi"
if((Tp<=50) && (Tp>0)) ht<-"Spos"
if(Tp==0) ht<-"G"
}

##Ya tenemos los macrobioclimas, ahora a por los ombrotipos (omb)
if(ht=="G") {
if(Pm<10) omb<-"us" else
if((Pm>=10) && (Pm<200)) omb<-"ls" else
if((Pm>=200) && (Pm<500)) omb<-"ss" else
if((Pm>=500) && (Pm<1000)) omb<-"hs" else
if(Pm>=1000) omb<-"hps" 
} else{
if(Io<0.1) omb<-"uhai"
if((Io>=0.1) && (Io<0.2)) omb<-"uhas"
if((Io>=0.2) && (Io<0.3)) omb<-"hai"
if((Io>=0.3) && (Io<0.4)) omb<-"has"
if((Io>=0.4) && (Io<0.7)) omb<-"ari"
if((Io>=0.7) && (Io<1.0)) omb<-"ars"
if((Io>=1.0) && (Io<1.5)) omb<-"sai"
if((Io>=1.5) && (Io<2.0)) omb<-"sas"
if((Io>=2.0) && (Io<2.8)) omb<-"sei"
if((Io>=2.8) && (Io<3.6)) omb<-"ses"
if((Io>=3.6) && (Io<4.8)) omb<-"sui"
if((Io>=4.8) && (Io<6.0)) omb<-"sus"
if((Io>=6.0) && (Io<9.0)) omb<-"hui"
if((Io>=9.0) && (Io<12.0)) omb<-"hus"
if((Io>=12.0) && (Io<18.0)) omb<-"hhi"
if((Io>=18.0) && (Io<=24.0)) omb<-"hhs"
if(Io>24.0 && Io<99) omb<-"uhu"
#if(Io==99) omb<-"NO"
}

##### Bioclimas #######
#Bioclimas Tropicales
bio=""
pm[13]<-pm[1]
pm[14]<-pm[2]
P3<-0
for(i in 1:12){
if((pm[i]<10) && (pm[i+1]<10) && (pm[i+2]<10)) P3<-1 else P3<-P3}

if(mc=="TR"){
if(Io>3.6) {
if(Iod2<2.5) bio<-"trps" else{ 
if(Tp>950) bio<-"trpl" else if(P3==1) bio<-"trps" else bio<-"trpl"
}
}else{
if(Io<=0.1) bio<-"trhd" else
if(Io>0.1 && Io<=1.0) bio<-"trde" else bio<-"trxe"
}}
if(mc=="M"){
if(Ic<=21){
if(Io<0.2) (bio<-"meho") else
if((Io>=0.2) && (Io<1.0)) bio<-"medo" else
if((Io>=1.0) && (Io<2.0)) bio<-"mexo" else if(Io>=2) bio<-"mepo"
} else {
if(Io<0.2) (bio<-"mehc") else
if((Io>=0.2) && (Io<1.0)) bio<-"medc" else
if((Io>=1.0) && (Io<2.0)) bio<-"mexc" else if(Io>=2) bio<-"mepc"
}}

if(mc=="T"){
if(Io<=3.6) bio<-"texe" else
if(Ic<=11) bio<-"teho" else
if(Ic<=21) bio<-"teoc" else bio<-"teco"
}
if(mc=="B"){
if(Ic>46) bio<-"bohc" else
if(Io<=3.6) bio<-"boxe" else{
if(Ic<=11) bio<-"boho" else
if((Ic>11) && (Ic<=21)) bio<-"booc" else
if((Ic>21) && (Ic<=28)) bio<-"bosc" else bio<-"boco" 
}
}
if(mc=="P"){
if(Tp==0) bio<-"pope" else 
if(Tp>0){
if(Io<=3.6) bio<-"poxe" else
if(Ic<=11) bio<-"poho" else
if((Ic>11) && (Ic<=21)) bio<-"pooc" else bio<-"poco"
}
}

#### Variantes bioclimáticas #######
vst<-""
Vstm<-""
if((bio=="trpl") || (bio=="trps")){
#Base para el cálculo de la sequía tropical(str)
#Índice ombrotérmico mensual (Iom)
Iom<-c(1:12)
for(i in 1:12){
Iom[i]<-(pm[i]/tm[i])
}
#Valor de sequía tropical mensual (vstm[i])
vstm<-c(1:12)
for (i in 1:12){
if(Iom[i]<2.5) (vstm[i]<-250-(10*Iom[i])) else (vstm[i]<-0)
}
#Sequía tropical anual (Vstm)
Vstm<-sum(vstm[1]:vstm[12])

#Sequía tropical para zonas tropicales pluviales
if(bio=="trpl"){
if(Vstm==0) vst<-"ph"
if(Vstm>0 && Vstm<=60) vst<-"psh"
if(Vstm>60 && Vstm<=220) vst<-"psbm"
}
#Seq4a tropical para zonas tropicales pluviestacionales
if(bio=="trps"){
if(Vstm>=0 && Vstm<=350) vst<-"psm"
if(Vstm>350 && Vstm<=700) vst<-"pssm"
if(Vstm>700 && Vstm<=1050) vst<-"pssx"
if(Vstm>1050) vst<-"psx"
}
}#Resto de variantes bioclimáticas
#Hemisferio Norte
vb<-""
if (hem==1){
if(((mc=="M") || (mc=="T") || (mc=="B")|| (mc=="P")) && (Ic>17) && (Ps>(1.1*Pw)) && (Io>0.2) && (Io<=4.8) && 
((pm[6]<3*(tm[6])) ||(pm[7]<3*(tm[7])) ||(pm[8]<3*(tm[8])))) vb<-"Est"
else 
if((mc=="T") && ((pm[6]<2.8*tm[6]) || (pm[7]<2.8*tm[7]) || (pm[8]<2.8*tm[8]))) vb<-"Sbm" 
else
if((mc=="TR") && ((pm[12]<=2*tm[12]) || (pm[1]<=2*tm[1]) || (pm[2]<=2*tm[2])) && ((pm[6]<=2*tm[6]) || (pm[7]<=2*tm[7]) || pm[8]<=2*tm[8]) &&
((pm[3]>=2*tm[3]) || (pm[4]>=2*tm[4]) || (pm[5]>=2*tm[5])) && ((pm[9]>=2*tm[9]) || (pm[10]>=2*tm[10]) || pm[8]>=2*tm[11])
) vb<-"Bix" else 
if((mc=="TR") && ((bio=="trps") || (bio=="trde") || (bio=="trxe")) && (((pm[6]+pm[7])*1.3)<(pm[8]+pm[9]))) vb<-"Spl" else
if((mc=="TR") && (bio!="trpl") && (bio!="trhd") && (Ps<Pw)) vb<-"Ant" else vb<-""}

#Hemisferio Sur
if(hem==2){
if(((mc=="M") || (mc=="T") || (mc=="B")|| (mc=="P")) && (Ic>17) && (Ps>(1.1*Pw)) && (Io>0.1) && (Io<=4.8) && 
((pm[12]<2.8*tm[12]) ||(pm[1]<2.8*tm[1]) ||(pm[2]<2.8*tm[2]))) vb<-"Est" 
else
if((mc=="T") && (hem==2) && ((pm[12]<2.8*tm[12]) || (pm[1]<2.8*tm[1]) || (pm[2]<2.8*tm[2]))) vb<-"Sbm" 
else
if((mc=="TR") && ((pm[12]<=2*tm[12]) || (pm[1]<=2*tm[1]) || (pm[2]<=2*tm[2])) && ((pm[6]<=2*tm[6]) || (pm[7]<=2*tm[7]) || pm[8]<=2*tm[8]) &&
((pm[3]>=2*tm[3]) || (pm[4]>=2*tm[4]) || (pm[5]>=2*tm[5])) && ((pm[9]>=2*tm[9]) || (pm[10]>=2*tm[10]) || pm[8]>=2*tm[11])
) vb<-"Bix" 
else 
if((mc=="TR") && ((bio=="trps") || (bio=="trde") || (bio=="trxe")) && (((pm[12]+pm[1])*1.3)<(pm[2]+pm[3]))) vb<-"Spl"
else
if((mc=="TR") && (bio!="trpl") && (bio!="trhd") && (Pw>Ps)) vb<-"Ant" else vb=""}



#Ahora tenemos la información suficiente para preparar el gráfico-cuadro resumen
#if(lang=="en") titulo<-"Climatic classifications" else titulo<-"Clasificaciones clim\\'aticas"

###rótulos en castellano:
if(lang=="es"){
if(hem==1) z<-"N" else z<-"S"
if(long3==1) zz<-"E" else zz<-"O"
titulo<-"Índices y diagnosis bioclimática"
#Cinturas latitudinales
if(cint=="ec") (cintura="Ecuatorial")
if(cint=="eutr") (cintura="Eutropical")
if(cint=="subtr") (cintura="Subtropical")
if(cint=="eut") (cintura="Eutemplada")
if(cint=="subts") (cintura="Subtemplada Septentrional")
if(cint=="subta") (cintura="Subtemplada Austral")
if(cint=="art") (cintura="Ártica")
if(cint=="anta") (cintura="Antártica")
#Continentalidad vs Oceanidad
if(cont1=="ho") (continentalidad1<-"Hiperoceánico")
if(cont1=="o") (continentalidad1<-"Oceánico")
if(cont1=="c") (continentalidad1<-"Continental")
if(cont2=="uha") (continentalidad2<-"Ultrahiperoceánico acusado")
if(cont2=="uht") (continentalidad2<-"Ultrahiperoceánico atenuado")
if(cont2=="euha") (continentalidad2<-"Euhiperoceánico acusado")
if(cont2=="euht") (continentalidad2<-"Euhiperoceánico atenuado")
if(cont2=="sbha") (continentalidad2<-"Subhiperoceánico acusado")
if(cont2=="sbht") (continentalidad2<-"Subhiperoceánico atenuado")
if(cont2=="sha") (continentalidad2<-"Semihiperoceánico acusado")
if(cont2=="sht") (continentalidad2<-"Semihiperoceánico atenuado")
if(cont2=="eoa") (continentalidad2<-"Euoceánico acusado")
if(cont2=="eot") (continentalidad2<-"Euoceánico atenuado")
if(cont2=="sca") (continentalidad2<-"Semicontinental acusado")
if(cont2=="sct") (continentalidad2<-"Semicontinental atenuado")
if(cont2=="sbca") (continentalidad2<-"Subcontinental acusado")
if(cont2=="sbct") (continentalidad2<-"Subcontinental atenuado")
if(cont2=="eca") (continentalidad2<-"Eucontinental acusado")
if(cont2=="ect") (continentalidad2<-"Eucontinental atenuado")
if(cont2=="hca") (continentalidad2<-"Hipercontinental acusado")
if(cont2=="hct") (continentalidad2<-"Hipercontinental atenuado")
#Macrobioclimas
if(mc=="TR") (macrobioclima<-"Tropical")
if(mc=="M") (macrobioclima<-"Mediterráneo")
if(mc=="T") (macrobioclima<-"Templado")
if(mc=="B") (macrobioclima<-"Boreal")
if(mc=="P") (macrobioclima<-"Polar")
#Horizones termotipicos tropicales
if(ht=="Itri") (horizonte<-"Infratropical inferior")
if(ht=="Itrs") (horizonte<-"Infratropical superior")
if(ht=="Ttri") (horizonte<-"Termotropical inferior")
if(ht=="Ttrs") (horizonte<-"Termotropical superior")
if(ht=="Mtri") (horizonte<-"Mesotropical inferior")
if(ht=="Mtrs") (horizonte<-"Mesotropical superior")
if(ht=="Stri") (horizonte<-"Supratropical inferior")
if(ht=="Strs") (horizonte<-"Supratropical superior")
if(ht=="Otri") (horizonte<-"Orotropical inferior")
if(ht=="Otrs") (horizonte<-"Orotropical superior")
if(ht=="Ctri") (horizonte<-"Criorotropical inferior")
if(ht=="Ctrs") (horizonte<-"Criorotropical superior")
if(ht=="G") (horizonte<-"Gélido")
#Horizontes termotípicos mediterráneos
if(ht=="Imei") (horizonte<-"Inframediterráneo inferior")
if(ht=="Imes") (horizonte<-"Inframediterráneo superior")
if(ht=="Tmei") (horizonte<-"Termomediterráneo inferior")
if(ht=="Tmes") (horizonte<-"Termomediterráneo superior")
if(ht=="Mmei") (horizonte<-"Mesomediterráneo inferior")
if(ht=="Mmes") (horizonte<-"Mesomediterráneo superior")
if(ht=="Smei") (horizonte<-"Supramediterráneo inferior")
if(ht=="Smes") (horizonte<-"Supramediterráneo superior")
if(ht=="Omei") (horizonte<-"Oromediterráneo inferior")
if(ht=="Omes") (horizonte<-"Oromediterráneo superior")
if(ht=="Cmei") (horizonte<-"Crioromediterráneo inferior")
if(ht=="Cmes") (horizonte<-"Crioromediterráneo superior")
#Horizontes termotípicos templados
if(ht=="Ite") (horizonte<-"Infratemplado")
if(ht=="Ttei") (horizonte<-"Termotemplado inferior")
if(ht=="Ttes") (horizonte<-"Termotemplado superior")
if(ht=="Mtei") (horizonte<-"Mesotemplado inferior")
if(ht=="Mtes") (horizonte<-"Mesotemplado superior")
if(ht=="Stei") (horizonte<-"Supratemplado inferior")
if(ht=="Stes") (horizonte<-"Supratemplado superior")
if(ht=="Otei") (horizonte<-"Orotemplado inferior")
if(ht=="Otes") (horizonte<-"Orotemplado superior")
if(ht=="Ctei") (horizonte<-"Criorotemplado inferior")
if(ht=="Ctes") (horizonte<-"Criorotemplado superior")
#Horizontes termotípicos boreales
if(ht=="Tboi") (horizonte<-"Termoboreal inferior")
if(ht=="Tbos") (horizonte<-"Termoboreal superior")
if(ht=="Mboi") (horizonte<-"Mesoboreal inferior")
if(ht=="Mbos") (horizonte<-"Mesoboreal superior")
if(ht=="Sboi") (horizonte<-"Supraboreal inferior")
if(ht=="Sbos") (horizonte<-"Supraboreal superior")
if(ht=="Oboi") (horizonte<-"Oroboreal inferior")
if(ht=="Obos") (horizonte<-"Oroboreal superior")
if(ht=="Cboi") (horizonte<-"Crioroboreal inferior")
if(ht=="Cbom") (horizonte<-"Crioroboreal medio")
if(ht=="Cbos") (horizonte<-"Crioroboreal superior")
#Horizontes termotípicos polares
if(ht=="Tpoi") (horizonte<-"Termopolar inferior")
if(ht=="Tpos") (horizonte<-"Termopolar superior")
if(ht=="Mpoi") (horizonte<-"Mesopolar inferior")
if(ht=="Mpos") (horizonte<-"Mesopolar superior")
if(ht=="Spoi") (horizonte<-"Suprapolar inferior")
if(ht=="Spos") (horizonte<-"Suprapolar superior")
#Horizontes ombrotípicos
if(omb=="uhai") (ombroclima<-"Ultrahiperárido inferior")
if(omb=="uhas") (ombroclima<-"Ultrahiperárido superior")
if(omb=="hai") (ombroclima<-"Hiperárido inferior")
if(omb=="has") (ombroclima<-"Hiperárido superior")
if(omb=="ari") (ombroclima<-"Árido inferior")
if(omb=="ars") (ombroclima<-"Árido superior")
if(omb=="sai") (ombroclima<-"Semiárido inferior")
if(omb=="sas") (ombroclima<-"Semiárido superior")
if(omb=="sei") (ombroclima<-"Seco inferior")
if(omb=="ses") (ombroclima<-"Seco superior")
if(omb=="sui") (ombroclima<-"Subhúmedo inferior")
if(omb=="sus") (ombroclima<-"Subhúmedo superior")
if(omb=="hui") (ombroclima<-"Húmedo inferior")
if(omb=="hus") (ombroclima<-"Húmedo superior")
if(omb=="hhi") (ombroclima<-"Hiperhúmedo inferior")
if(omb=="hhs") (ombroclima<-"Hiperhúmedo superior")
if(omb=="uhu") (ombroclima<-"Ultrahiperhúmedo")
if(omb=="us") (ombroclima<-"No nivoso")
if(omb=="ls") (ombroclima<-"Con baja innivación")
if(omb=="ss") (ombroclima<-"Seminivoso")
if(omb=="hs") (ombroclima<-"Muy nivoso")
if(omb=="hps") (ombroclima<-"Hipernivoso")
#Bioclimas
if(bio=="trpl") (bioclima<-"Tropical pluvial")
if(bio=="trps") (bioclima<-"Tropical pluviestacional")
if(bio=="trxe") (bioclima<-"Tropical xérico")
if(bio=="trde") (bioclima<-"Tropical desértico")
if(bio=="trhd") (bioclima<-"Tropical hiperdesértico")
if(bio=="mepo") (bioclima<-"Mediterráneo pluviestacional-oceánico")
if(bio=="mepc") (bioclima<-"Mediterráneo pluviestacional-continental")
if(bio=="mexo") (bioclima<-"Mediterráneo xérico-oceánico")
if(bio=="mexc") (bioclima<-"Mediterráneo xérico-continental")
if(bio=="medo") (bioclima<-"Mediterráneo desértico-oceánico")
if(bio=="medc") (bioclima<-"Mediterráneo desértico-continental")
if(bio=="meho") (bioclima<-"Mediterráneo hiperdesértico-oceánico")
if(bio=="mehc") (bioclima<-"Mediterráneo hiperdesértico-continental")
if(bio=="teho") (bioclima<-"Templado hiperoceánico")
if(bio=="teoc") (bioclima<-"Templado oceánico")
if(bio=="teco") (bioclima<-"Templado continental")
if(bio=="texe") (bioclima<-"Templado xérico")
if(bio=="boho") (bioclima<-"Boreal hiperoceánico")
if(bio=="booc") (bioclima<-"Boreal oceánico")
if(bio=="bosc") (bioclima<-"Boreal subcontinental")
if(bio=="boco") (bioclima<-"Boreal continental")
if(bio=="bohc") (bioclima<-"Boreal hipercontinental")
if(bio=="boxe") (bioclima<-"Boreal xérico")
if(bio=="poho") (bioclima<-"Polar hiperoceánico")
if(bio=="pooc") (bioclima<-"Polar oceánico")
if(bio=="poco") (bioclima<-"Polar continental")
if(bio=="poxe") (bioclima<-"Polar xérico")
if(bio=="pope" ) (bioclima<-"Polar pergélido")
#Variantes bioclimáticas
if(vb=="Est") variante<-"Esteparia"
if(vb=="Sbm") variante<-"Submediterránea"
if(vb=="Bix") variante<-"Bixérica"
if(vb=="Ant") variante<-"Antitropical"
if(vb=="Spl") variante<-"Seropluvial"
if(vb=="") variante<-""
#Sequía tropical
if(vst=="ph") sequiat<-"Pluvial higrofítica"
if(vst=="psh") sequiat<-"Pluvial subhigrofítica"
if(vst=="psbm") sequiat<-"Pluvial submesofítica"
if(vst=="psm") sequiat<-"Pluviestacional mesofítica"
if(vst=="pssm") sequiat<-"Pluviestacional submesofítica"
if(vst=="pssx") sequiat<-"Pluviestacional subxerofítica"
if(vst=="psx") sequiat<-"Pluviestacional xerofítica"
}


else {#Está en inglés
#rótulos:
if(hem==1) z<-"N" else z<-"S"
if(long3==1) zz<-"E" else zz<-"W"
titulo<-"Bioclimatic indexes and diagnosis"
#Cinturas latitudinales
if(cint=="ec") (cintura="Ecuatorial")
if(cint=="eutr") (cintura="Eutropical")
if(cint=="subtr") (cintura="Subtropical")
if(cint=="eut") (cintura="Eutemperate")
if(cint=="subts") (cintura="Subtemperate Septentrional")
if(cint=="subta") (cintura="Subtemperate Austral")
if(cint=="art") (cintura="Artic")
if(cint=="anta") (cintura="Antartic")
#Continentalidad vs Oceanidad
if(cont1=="ho") (continentalidad1<-"Hyperoceanic")
if(cont1=="o") (continentalidad1<-"Oceanic")
if(cont1=="c") (continentalidad1<-"Continental")
if(cont2=="uha") (continentalidad2<-"High Ultrahyperoceanic")
if(cont2=="uht") (continentalidad2<-"Low Ultrahyperoceanic")
if(cont2=="euha") (continentalidad2<-"High Euhyperoceanic")
if(cont2=="euht") (continentalidad2<-"Low Euhyperoceanic")
if(cont2=="sbha") (continentalidad2<-"High Subhyperoceanic")
if(cont2=="sbht") (continentalidad2<-"Low Subhyperoceanic")
if(cont2=="sha") (continentalidad2<-"High Semihyperoceanic")
if(cont2=="sht") (continentalidad2<-"Low Semihyperoceanic")
if(cont2=="eoa") (continentalidad2<-"High Euoceanic")
if(cont2=="eot") (continentalidad2<-"Low Euoceanic")
if(cont2=="sca") (continentalidad2<-"High Semicontinental")
if(cont2=="sct") (continentalidad2<-"Low Semicontinental")
if(cont2=="sbca") (continentalidad2<-"High Subcontinental")
if(cont2=="sbct") (continentalidad2<-"Low Subcontinental")
if(cont2=="eca") (continentalidad2<-"High Eucontinental")
if(cont2=="ect") (continentalidad2<-"Low Eucontinental")
if(cont2=="hca") (continentalidad2<-"High Hypercontinental")
if(cont2=="hct") (continentalidad2<-"Low Hypercontinental")
#Macrobioclimas
if(mc=="TR") (macrobioclima<-"Tropical")
if(mc=="M") (macrobioclima<-"Mediterranean")
if(mc=="T") (macrobioclima<-"Temperate")
if(mc=="B") (macrobioclima<-"Boreal")
if(mc=="P") (macrobioclima<-"Polar")
#Horizones termotipicos tropicales
if(ht=="Itri") (horizonte<-"Lower Infratropical")
if(ht=="Itrs") (horizonte<-"Upper Infratropical")
if(ht=="Ttri") (horizonte<-"Lower Thermotropical")
if(ht=="Ttrs") (horizonte<-"Upper Thermotropical")
if(ht=="Mtri") (horizonte<-"Lower Mesotropical")
if(ht=="Mtrs") (horizonte<-"Upper Mesotropical")
if(ht=="Stri") (horizonte<-"Lower Supratropical")
if(ht=="Strs") (horizonte<-"Upper Supratropical")
if(ht=="Otri") (horizonte<-"Lower Orotropical")
if(ht=="Otrs") (horizonte<-"Upper Orotropical")
if(ht=="Ctri") (horizonte<-"Lower Cryorotropical")
if(ht=="Ctrs") (horizonte<-"Upper Cryorotropical")
if(ht=="G") (horizonte<-"Gelid")
#Horizontes termotípicos mediterráneos
if(ht=="Imei") (horizonte<-"Low Inframediterranean")
if(ht=="Imes") (horizonte<-"Upper Inframediterranean")
if(ht=="Tmei") (horizonte<-"Low Thermomediterranean")
if(ht=="Tmes") (horizonte<-"Upper Thermomediterranean")
if(ht=="Mmei") (horizonte<-"Low Mesomediterranean")
if(ht=="Mmes") (horizonte<-"Upper Mesomediterranean")
if(ht=="Smei") (horizonte<-"Low Supramediterranean")
if(ht=="Smes") (horizonte<-"Upper Supramediterranean")
if(ht=="Omei") (horizonte<-"Low Oromediterranean")
if(ht=="Omes") (horizonte<-"Upper Oromediterranean")
if(ht=="Cmei") (horizonte<-"Low Cryoromediterranean")
if(ht=="Cmes") (horizonte<-"Upper Cryoromediterranean")
#Horizontes termotípicos templados
if(ht=="Ite") (horizonte<-"Infratemperate")
if(ht=="Ttei") (horizonte<-"Lower Thermotemperate")
if(ht=="Ttes") (horizonte<-"Upper Thermotemperate")
if(ht=="Mtei") (horizonte<-"Lower Mesotemperate")
if(ht=="Mtes") (horizonte<-"Upper Mesotemperate")
if(ht=="Stei") (horizonte<-"Lower Supratemperate")
if(ht=="Stes") (horizonte<-"Upper Supratemperate")
if(ht=="Otei") (horizonte<-"Lower Orotemperate")
if(ht=="Otes") (horizonte<-"Upper Orotemperate")
if(ht=="Ctei") (horizonte<-"Lower Cryorotemperate")
if(ht=="Ctes") (horizonte<-"Upper Cryorotemperate")
#Horizontes termotípicos boreales
if(ht=="Tboi") (horizonte<-"Lower Thermoboreal")
if(ht=="Tbos") (horizonte<-"Upper Thermoboreal")
if(ht=="Mboi") (horizonte<-"Lower Mesoboreal")
if(ht=="Mbos") (horizonte<-"Upper Mesoboreal")
if(ht=="Sboi") (horizonte<-"Lower Supraboreal")
if(ht=="Sbos") (horizonte<-"Upper Supraboreal")
if(ht=="Oboi") (horizonte<-"Lower Oroboreal")
if(ht=="Obos") (horizonte<-"Upper Oroboreal")
if(ht=="Cboi") (horizonte<-"Lower Cryoroboreal")
if(ht=="Cbom") (horizonte<-"Medium Cryoroboreal")
if(ht=="Cbos") (horizonte<-"Upper Cryoroboreal")
#Horizontes termotípicos polares
if(ht=="Tpoi") (horizonte<-"Lower Termopolar")
if(ht=="Tpos") (horizonte<-"Upper Termopolar")
if(ht=="Mpoi") (horizonte<-"Lower Mesopolar")
if(ht=="Mpos") (horizonte<-"Upper Mesopolar")
if(ht=="Spoi") (horizonte<-"Lower Suprapolar")
if(ht=="Spos") (horizonte<-"Upper Suprapolar")
#Horizontes ombrotípicos
if(omb=="NO") (ombroclima<-"Snowy")
if(omb=="uhai") (ombroclima<-"Lower Ultrahyperarid")
if(omb=="uhas") (ombroclima<-"Upper Ultrahyperarid")
if(omb=="hai") (ombroclima<-"Lower Hyperarid")
if(omb=="has") (ombroclima<-"Upper Hyperarid")
if(omb=="ari") (ombroclima<-"Lower Arid")
if(omb=="ars") (ombroclima<-"Upper Arid")
if(omb=="sai") (ombroclima<-"Lower Semiarid")
if(omb=="sas") (ombroclima<-"Upper Semiarid")
if(omb=="sei") (ombroclima<-"Lower Dry")
if(omb=="ses") (ombroclima<-"Upper Dry")
if(omb=="sui") (ombroclima<-"Lower Subhumid")
if(omb=="sus") (ombroclima<-"Upper Subhumid")
if(omb=="hui") (ombroclima<-"Lower Humid")
if(omb=="hus") (ombroclima<-"Upper Humid")
if(omb=="hhi") (ombroclima<-"Lower Hyperhumid")
if(omb=="hhs") (ombroclima<-"Upper Hyperhumid")
if(omb=="uhu") (ombroclima<-"Ultrahyperhumid")
if(omb=="us") (ombroclima<-"unsnowy")
if(omb=="ls") (ombroclima<-"low-snowy")
if(omb=="ss") (ombroclima<-"semi-snowy")
if(omb=="hs") (ombroclima<-"high-snowy")
if(omb=="hps") (ombroclima<-"hyper-snowy")
#Bioclimas
if(bio=="trpl") (bioclima<-"Tropical pluvial")
if(bio=="trps") (bioclima<-"Tropical pluviseasonal")
if(bio=="trxe") (bioclima<-"Tropical xeric")
if(bio=="trde") (bioclima<-"Tropical desertic")
if(bio=="trhd") (bioclima<-"Tropical hyperdesertic")
if(bio=="mepo") (bioclima<-"Mediterráneo pluviseasonal-oceanic")
if(bio=="mepc") (bioclima<-"Mediterráneo pluviseasonal-continental")
if(bio=="mexo") (bioclima<-"Mediterráneo xeric-oceanic")
if(bio=="mexc") (bioclima<-"Mediterráneo xeric-continental")
if(bio=="medo") (bioclima<-"Mediterráneo desertic-oceanic")
if(bio=="medc") (bioclima<-"Mediterráneo desertic-continental")
if(bio=="meho") (bioclima<-"Mediterráneo hyperdesertic-oceanic")
if(bio=="mehc") (bioclima<-"Mediterráneo hyperdesertic-continental")
if(bio=="teho") (bioclima<-"Temperate hyperoceanic")
if(bio=="teoc") (bioclima<-"Temperate oceanic")
if(bio=="teco") (bioclima<-"Temperate continental")
if(bio=="texe") (bioclima<-"Temperate xeric")
if(bio=="boho") (bioclima<-"Boreal hyperoceanic")
if(bio=="booc") (bioclima<-"Boreal oceanic")
if(bio=="bosc") (bioclima<-"Boreal subcontinental")
if(bio=="boco") (bioclima<-"Boreal continental")
if(bio=="bohc") (bioclima<-"Boreal hypercontinental")
if(bio=="boxe") (bioclima<-"Boreal xeric")
if(bio=="poho") (bioclima<-"Polar hyperoceanic")
if(bio=="pooc") (bioclima<-"Polar oceanic")
if(bio=="poco") (bioclima<-"Polar continental")
if(bio=="poxe") (bioclima<-"Polar xeric")
if(bio=="pope" ) (bioclima<-"Polar pergelid")
#Variantes bioclimáticas
if(vb=="Est") variante<-"Steppic"
if(vb=="Sbm") variante<-"Submediterranean"
if(vb=="Bix") variante<-"Bixeric"
if(vb=="Ant") variante<-"Antitropical"
if(vb=="Spl") variante<-"Pluviserotin"
if(vb=="") variante<-""
##Sequía tropical: OJO, FALTA TRADUCIR AL INGLÉS
if(vst=="ph") sequiat<-"Pluvial higrofítica"
if(vst=="psh") sequiat<-"Pluvial subhigrofítica"
if(vst=="psbm") sequiat<-"Pluvial submesofítica"
if(vst=="psm") sequiat<-"Pluviestacional mesofítica"
if(vst=="pssm") sequiat<-"Pluviestacional submesofítica"
if(vst=="pssx") sequiat<-"Pluviestacional subxerofítica"
if(vst=="psx") sequiat<-"Pluviestacional xerofítica"
}

if(lang=="es"){

plot.new()
#Título e información de la localidad
if(hem==1) z<-"N" else z<-"S"
mtext(titulo,line=1,adj=0.5,font=2,cex=0.6,col="red")
text(-0.04,1,paste("",est," [",alt," m]"),adj=0,col="blue",font=2)
text(-0.04,0.95,paste(" Lat.: ",lat1,"\\de ",lat2,"' ",z,", ",long1,"\\de ",long2,"' ",zz,sep=""),adj=0,col="blue",font=2)

#Línea doble superior
abline(0.9,0,col="blue")
abline(0.89,0,col="blue")

#Línea discontínua de separación
abline(0.85,0,col="blue",lty=6)

#Clasificaciones
#Clasificaciones
text(0.0,0.81,"Media de las máximas del mes más frío (M)",adj=0,font=2,cex=0.6)
text(0.90,0.81,format(round(tma[m],digit=2),nsmall=1),adj=1,font=2,cex=0.6)

text(0.0,0.78,"Media de las mínimas del mes más frío (m)",adj=0,font=2,cex=0.6)
text(0.90,0.78,format(round(tmi[m],digit=2)),adj=1,font=2,cex=0.6)


text(0.0,0.75,"Índice de termicidad (It)",adj=0,font=2,cex=0.6)
text(0.90,0.75,format(trunc(It)),adj=1,font=2,cex=0.6)

text(0.0,0.72,"Índice de termicidad compensado (Itc)",adj=0,font=2,cex=0.6)
text(0.90,0.72,format(trunc(Itc)),adj=1,font=2,cex=0.6)

text(0.0,0.69,"Índice de continentalidad (Ic)",adj=0,font=2,cex=0.6)
text(0.90,0.69,format(round(Ic,digit=1)),adj=1,font=2,cex=0.6)

text(0.0,0.66,"Índice de diurnalidad (Id)",adj=0,font=2,cex=0.6)
text(0.90,0.66,format(Id,digit=2,nsmall=1),adj=1,font=2,cex=0.6)

if(Io=="NO"){
text(0.0,0.63,"Índice ombrotérmico anual (Io)",adj=0,font=2,cex=0.6)
text(0.90,0.63,Io,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.63,"Índice ombrotérmico anual (Io)",adj=0,font=2,cex=0.6)
text(0.90,0.63,format(round(Io,digit=2),nsmall=1),adj=1,font=2,cex=0.6)}

if(mc=="TR"){
if(Iod1=="NO"){
text(0.0,0.60,"Índice ombrotérmico mensual de sequía (Iod1)",adj=0,font=2,cex=0.6)
text(0.90,0.60,Iod1,adj=1,font=2,cex=0.6)
} else{
text(0.0,0.60,"Índice ombrotérmico mensual de sequía (Iod1)",adj=0,font=2,cex=0.6)
text(0.90,0.60,format(round(Iod1,digit=2),nsmall=2),adj=1,font=2,cex=0.6)}

if(Iod2=="NO"){
text(0.0,0.57,"Índice ombrotérmico bimensual de sequía (Iod2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,Iod2,adj=01,font=2,cex=0.6)}
else{
text(0.0,0.57,"Índice ombrotérmico bimensual de sequía (Iod2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,format(round(Iod2,digit=2),nsmall=2),adj=1,font=2,cex=0.6)
}

if(Iod3=="NO") {
text(0.0,0.54,"Índice ombrotérmico trimestral de sequía (Iod3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,Iod3,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.54,"Índice ombrotérmico trimestral de sequía (Iod3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,format(round(Iod3,digit=2),nsmall=1),adj=1,font=2,cex=0.6)
}

if(Iosc4=="NO"){
text(0.0,0.51,"Índice ombrotérmico cuatrimestral de sequía (Iod4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,Iosc4,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.51,"Índice ombrotérmico cuatrimestral de sequía (Iod4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,format(round(Iod4,digit=2),nsmall=2),adj=1,font=2,cex=0.6)
}

}else
{text(0.0,0.60,"Índice ombrotérmico mensual estival (Ios1)",adj=0,font=2,cex=0.6)
text(0.90,0.60,format(round(Ios1,digit=2),nsmall=2),adj=1,font=2,cex=0.6)

if(Ios2=="NO"){
text(0.0,0.57,"Índice ombrotérmico bimensual estival (Ios2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,Ios2,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.57,"Índice ombrotérmico bimensual estival (Ios2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,format(round(Ios2,digit=2),nsmall=1),adj=1,font=2,cex=0.6)}

if(Iosc3=="NO") {
text(0.0,0.54,"Índice ombrotérmico trimestral estival (Ios3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,Iosc3,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.54,"Índice ombrotérmico trimestral estival (Ios3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,format(round(Iosc3,digit=2),nsmall=2),adj=1,font=2,cex=0.6)}

if(Iosc4=="NO"){
text(0.0,0.51,"Índice ombrotérmico cuatrimestral estival (Ios4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,Iosc4,adj=1,font=2,cex=0.6)}
else{
text(0.0,0.51,"Índice ombrotérmico cuatrimestral estival (Ios4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,format(round(Iosc4,digit=2),nsmall=2),adj=1,font=2,cex=0.6)}
}
text(0.0,0.48,"Temperaturas positivas (Tp):",adj=0,font=2,cex=0.6)
text(0.90,0.48,format(trunc(Tp)),adj=1,font=2,cex=0.6)

text(0.0,0.45,"Temperaturas negativas (Tn):",adj=0,font=2,cex=0.6)
text(0.90,0.45,format(trunc(Tn)),adj=1,font=2,cex=0.6)

text(0.0,0.42,"Temperatura estival (Ts):",adj=0,font=2,cex=0.6)
text(0.90,0.42,format(trunc(Ts)),adj=1,font=2,cex=0.6)

text(0.0,0.39,"Precipitación positiva (Pp):",adj=0,font=2,cex=0.6)
text(0.90,0.39,format(trunc(Pp)),adj=1,font=2,cex=0.6)

text(0.0,0.36,"Cintura latitudinal:",adj=0,font=2,cex=0.6)
text(0.90,0.36,cintura,adj=1,font=2,cex=0.6,col="red")

text(0.0,0.33,"Continentalidad:",adj=0,font=2,cex=0.6)
text(0.90,0.33,paste(continentalidad1,"-",continentalidad2),adj=1,font=2,cex=0.6,col="red")

if(vb==""){
text(0.0,0.30,"Bioclima:",adj=0,font=2,cex=0.6)
text(0.90,0.30,bioclima,adj=1,font=2,cex=0.6,col="red")
} else
{text(0.0,0.30,"Bioclima (Variante):",adj=0,font=2,cex=0.6)
text(0.90,0.30,paste(bioclima,"(",variante,")"),adj=1,font=2,cex=0.6,col="red")}

if((Vstm!="NO") && ((bio=="trpl") || (bio=="trps"))){
text(0.0,0.27,"Sequía tropical:",adj=0,font=2,cex=0.6)
text(0.90,0.27,sequiat,adj=1,font=2,cex=0.6,col="red")
text(0.0,0.24,"Piso bioclimático:",adj=0,font=2,cex=0.6)
text(0.90,0.24,paste(horizonte, ombroclima),adj=1,font=2,cex=0.6,col="red")}
else{
text(0.0,0.27,"Piso bioclimático:",adj=0,font=2,cex=0.6)
text(0.90,0.27,paste(horizonte, ombroclima),adj=1,font=2,cex=0.6,col="red")
}} else

if(lang=="en"){
##OJO, HAY QUE REHACERLO, DADOS LOS CAMBIOS HECHOS EN EL APARTADO EN CASTELLANO
plot.new()
#Título e información de la localidad
if(hem==1) z<-"N" else z<-"S"
mtext(titulo,line=1,adj=0.5,font=2,cex=0.6,col="red")
text(-0.04,1,paste("",est," [",alt," m]"),adj=0,col="blue",font=2,cex=0.6)
text(-0.04,0.95,paste(" Lat.: ",lat1,"\\de ",lat2,"' ",z,", ",long1,"\\de ",long2,"' ",zz,sep=""),adj=0,col="blue",font=2,cex=0.6)

#Línea doble superior
abline(0.9,0,col="blue")
abline(0.89,0,col="blue")

#Línea discontínua de separación
abline(0.85,0,col="blue",lty=6)

#Clasificaciones
text(0.10,0.81,"Media de las máximas del mes más frío (M)",adj=0,font=2,cex=0.6)
text(0.90,0.81,format(round(tma[m],digit=2)),adj=1,font=2,cex=0.6)

text(0.10,0.78,"Media de las mínimas del mes más frío (m)",adj=0,font=2,cex=0.6)
text(0.90,0.78,format(round(tmi[m],digit=2)),adj=1,font=2,cex=0.6)


text(0.10,0.75,"Thermicity index (It)",adj=0,font=2,cex=0.6)
text(0.90,0.75,format(trunc(It)),adj=1,font=2,cex=0.6)

text(0.10,0.72,"Compensated thermicity index (Itc)",adj=0,font=2,cex=0.6)
text(0.90,0.72,format(trunc(Itc)),adj=1,font=2,cex=0.6)

text(0.10,0.69,"Continentality index (Ic)",adj=0,font=2,cex=0.6)
text(0.90,0.69,format(round(Ic,digit=1)),adj=1,font=2,cex=0.6)

text(0.10,0.66,"Diurnality index (Id)",adj=0,font=2,cex=0.6)
text(0.90,0.66,format(Id,digit=2,nsmall=1),adj=1,font=2,cex=0.6)

if(Io=="NO"){
text(0.10,0.63,"Annual ombrothermic index (Io)",adj=0,font=2,cex=0.6)
text(0.90,0.63,Io,adj=1,font=2,cex=0.6)}
else{
text(0.10,0.63,"Annual ombrothermic index (Io)",adj=0,font=2,cex=0.6)
text(0.90,0.63,format(round(Io,digit=2),nsmall=1),adj=1,font=2,cex=0.6)}

text(0.10,0.60,"Monthly estival ombrothermic index (Ios1)",adj=0,font=2,cex=0.6)
text(0.90,0.60,format(Ios1,digit=2,nsmall=1),adj=1,font=2,cex=0.6)

if(Ios2=="NO"){
text(0.10,0.57,"Bimonthly estival ombrothermic index (Ios2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,Ios2,adj=1,font=2,cex=0.6)}
else{
text(0.10,0.57,"Bimonthly estival ombrothermic index (Ios2)",adj=0,font=2,cex=0.6)
text(0.90,0.57,format(round(Ios2,digit=2),nsmall=1),adj=1,font=2,cex=0.6)}

if(Iosc3=="NO") {
text(0.10,0.54,"Threemonthly estival ombrothermic index (Ios3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,Iosc3,adj=1,font=2,cex=0.6)}
else{
text(0.10,0.54,"Threemonthly estival ombrothermic index (Ios3):",adj=0,font=2,cex=0.6)
text(0.90,0.54,format(round(Iosc3,digit=2),nsmall=2),adj=1,font=2,cex=0.6)}

if(Iosc4=="NO"){
text(0.10,0.51,"Fourmonthly estival ombrothermic index (Ios4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,Iosc4,adj=1,font=2,cex=0.6)}
else{
text(0.10,0.51,"Fourmonthly estival ombrothermic index (Ios4):",adj=0,font=2,cex=0.6)
text(0.90,0.51,format(round(Iosc4,digit=2),nsmall=2),adj=1,font=2,cex=0.6)}

text(0.10,0.48,"Positive temperature (Tp):",adj=0,font=2,cex=0.6)
text(0.90,0.48,format(trunc(Tp)),adj=1,font=2,cex=0.6)

text(0.10,0.45,"Negative temperature (Tn):",adj=0,font=2,cex=0.6)
text(0.90,0.45,format(trunc(Tn)),adj=1,font=2,cex=0.6)

text(0.10,0.42,"Estival temperature (Ts):",adj=0,font=2,cex=0.6)
text(0.90,0.42,format(trunc(Ts)),adj=1,font=2,cex=0.6)

text(0.10,0.39,"Positive precipitation (Pp):",adj=0,font=2,cex=0.6)
text(0.90,0.39,format(trunc(Pp)),adj=1,font=2,cex=0.6)

text(0.10,0.36,"Latitudinal belt:",adj=0,font=2,cex=0.6)
text(0.90,0.36,cintura,adj=1,font=2,cex=0.6,col="red")

text(0.10,0.33,"Continentality:",adj=0,font=2,cex=0.6)
text(0.90,0.33,paste(continentalidad1,"-",continentalidad2),adj=1,font=2,cex=0.6,col="red")

if(vb==""){
text(0.10,0.30,"Bioclimate:",adj=0,font=2,cex=0.6)
text(0.90,0.30,bioclima,adj=1,font=2,cex=0.6,col="red")
} else
{text(0.10,0.30,"Bioclimate (Variant):",adj=0,font=2,cex=0.6)
text(0.90,0.30,paste(bioclima,"(",variante,")"),adj=1,font=2,cex=0.6,col="red")}

if((Vstm!="NO") && ((bio=="trpl") || (bio=="trps")) ){
text(0.10,0.27,"Tropical dryness:",adj=0,font=2,cex=0.6)
text(0.90,0.27,sequiat,adj=1,font=2,cex=0.6)
text(0.40,0.24,"Bioclimatic belt:",adj=0,font=2,cex=0.6)
text(0.90,0.24,paste(horizonte, ombroclima),adj=1,font=2,cex=0.6,col="red")} 
else{
text(0.10,0.27,"Bioclimatic belt:",adj=0,font=2,cex=0.6)}
text(0.90,0.27,paste(horizonte, ombroclima),adj=1,font=2,cex=0.6,col="red")
}
 
#Línea discontínua inferior
abline(0.16,0,col="blue",lty=6)

#Doble línea final
abline(0.09,0,col="blue")
abline(0.08,0,col="blue")

}


}#Final del fichero