##Diagrama de barras de precipitaciones mensuales
##Francisco Alcaraz Ariza (Murcia, Spain)

##Versión 2.0, 16 de febrero de 2011
#Arreglados problemas con layout si viene de pmbar

##Versión 1.1
tmbar <-function(file,lang="es",shem=FALSE) {
par(family="HersheySans")
plot.new()
#Limpiamos dat y loc de memoria por si se hubieran cargado con anterioridad
#if(exists("dat")) rm(dat)
#if(exists("loc")) rm(loc)
#Cargamos los ficheros
paste(file,".dat",sep="")->file1
paste(file,".loc",sep="")->file2
read.table(file1,header=T)->dat
read.table(file2,header=T)->loc
#etiquetas de los meses
if(lang=="en") mlab=c("J","F","M","A","M","J","J","A","S","O","N","D")
else mlab=c("E","F","M","A","M","J","J","A","S","O","N","D")
if(lang=="en") titulo="Monthly average temperature distribution"
else titulo="Distribuci\\'on mensual de temperaturas medias"
hem=loc[1,7]
if(hem=="2") shem=TRUE 
else shem=FALSE
if(shem) {#Hemisferio sur: desplazar los datos medio año
m1 <- dat[1:6,]
m2 <- dat[7:12,]
dat<-rbind(m2,m1)
mlab<-c(mlab[7:12],mlab[1:6])
}
attach(dat)
attach(loc)
m<-matrix(1,1)
layout(m)

#Controlamos número de columnas en el fichero de datos
nc<-ncol(dat)
#Temperaturas medias mensuales
if(nc==4) {tm<-(tma+tmi)/2}
#En caso contrario es evidente que la segunda columna, interpretada por «attach» es tm

barplot(tm,col="red",border="dark blue",names.arg=mlab,main=titulo)
abline(0,0)

mtext(paste(est," (",alt," m)"),line=0.5,adj=0.5)

#Restablecemos parámetros gráficos anteriores, para evitar efectos indeseados cuando otras funciones tengan una salida gráfica
invisible()
m<-matrix(c(1,1,1,1,1,1,1,1),4,2,byrow=T)
layout(m)
}